program testTGVision;
uses dos,Memory,Objects,Drivers,TGDriver,TGViews,TGMenus,TGApp,TGdialog,tgStdDlg,TGcalc,TGPuzzle, TGMineSW, TGCalend;
const cmInfo=201;
      cmopen =203;
      cmchangedir=204;
      cmcalculator=205;
      cmpuzzle=206;
      cmCalendar=207;
      cmMineSweeper=208;
      hcOpen=200;
      hcChangeDir=201;
      hcMineMenu=202;
      hcCalc=203;
      hcMinex=204;
      hcMiney=205;
      hcMineb=206;
      hcKalender=207;
      hcPuzzle=208;
      hcInfo=209;

type TProg = object(TApplication)
       procedure initMenuBar; virtual;
       procedure HandleEvent(var Event: TEvent); virtual;
       procedure InitStatusLine; virtual;
       procedure info;
       procedure fileopen;
       procedure changedir;
     end;

function ExecDialog(P: PDialog; Data: Pointer): Word;
var
  Result: Word;
begin
  Result := cmCancel;
  P := PDialog(Application^.ValidView(P));
  if P <> nil then
  begin
    if Data <> nil then P^.SetData(Data^);
    Result := DeskTop^.ExecView(P);
    if (Result <> cmCancel) and (Data <> nil) then P^.GetData(Data^);
    Dispose(P, Done);
  end;
  ExecDialog := Result;
end;


procedure TProg.info;
var win:PDialog;
    r:trect;
    dx,dy:worD;
begin
  r.assign(20,10,360,170);
  new(win,init(r,'Turbo Graphic Vision'));
  win^.options:=win^.options or ofcentered;
  r.assign(20,20,300,170);
  win^.insert(new(PStaticText,init(r,#3+'Turbo Graphic Vision'#13#13'Version 1.0'#13#13'Copyright (c) 1992 by'#13#13+
                                     'Florian Schreck'#13#13'2:241/7011.5 (Ab Mitte Oktober 92)')));
  r.assign(120,132,200,145);
  win^.insert(new(PButton,init(r,'~O~k',cmCancel,bfdefault)));
  desktop^.insert(win);
end;

procedure TProg.FileOpen;
var
  FileName: FNameStr;
begin
  FileName := '*.*';
  if ExecDialog(New(PFileDialog, Init('*.*', 'Open file',
    '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then;
end;

procedure TProg.ChangeDir;
begin
  ExecDialog(New(PChDirDialog, Init(cdNormal, 0)), nil);
end;

procedure TProg.initMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 12;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('~F~ile', hcNoContext, NewMenu(
      NewItem('~O~pen...', 'F3', kbF3, cmopen, hcOpen,
      NewLine(
      NewItem('~C~hange dir...', '', kbNoKey, cmChangeDir, hcChangeDir,
      NewItem('E~x~it', 'Alt-X', kbAltX, cmQuit, hcNoContext,
      NewSubMenu('~U~ntermenu', hcNoContext, NewMenu(
         NewItem('E~x~it', 'Alt-X', kbAltX, cmQuit, hcNoContext,
         NewSubMenu('~U~ntermenu', hcNoContext, NewMenu(
            NewItem('E~x~it', 'Alt-X', kbAltX, cmQuit, hcNoContext,nil
      )),nil))),nil)))))),
    NewSubMenu('~W~indows', hcNoContext, NewMenu(
      NewItem('~C~opyright', '', kbNoKey, cmInfo, hcInfo,
      NewItem('Ca~l~culator', '', kbNoKey, cmCalculator, hcCalc,
      NewItem('~K~alender', '', kbNoKey, cmCalendar, hcKalender,
      NewItem('P~u~zzle', '', kbNoKey, cmPuzzle, hcPuzzle,
      NewItem('~M~ine Sweeper', '', kbNoKey, cmMineSweeper, hcMineMenu,
      nil)))))),
    nil)))));
end;

procedure TProg.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 12;
  New(StatusLine, Init(R,
   NewStatusDef(0, 199,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~F10~ Menu', kbF10, cmMenu,
      NewStatusKey('', kbAltF3, cmClose,
      NewStatusKey('', kbF5, cmZoom,
      NewStatusKey('', kbCtrlF5, cmResize,
      NewStatusKey('', kbF6, cmNext, nil)))))),
    NewStatusDef(hcopen, hcopen,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~H~ilfe', kbF10, cmMenu,
      NewStatusKey('Suche eine Datei aus', kbAltF3, cmClose,nil))),
    NewStatusDef(hcchangedir, hcchangedir,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~H~ilfe', kbF10, cmMenu,
      NewStatusKey('Wechsle das Verzeichnis', kbAltF3, cmClose,nil))),
    NewStatusDef(hcMineMenu, hcMineMenu,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~H~ilfe', kbF10, cmMenu,
      NewStatusKey('Entschrfe Bomben', kbAltF3, cmClose,nil))),
    NewStatusDef(hcCalc, hcCalc,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~H~ilfe', kbF10, cmMenu,
      NewStatusKey('Ein Taschenrechner', kbAltF3, cmClose,nil))),
    NewStatusDef(hcMinex, hcMinex,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~H~ilfe', kbF10, cmMenu,
      NewStatusKey('Gebe die Breite des Spielfeldes an', kbAltF3, cmClose,nil))),
    NewStatusDef(hcMiney, hcMiney,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~H~ilfe', kbF10, cmMenu,
      NewStatusKey('Gebe die Hhe des Spielfeldes an', kbAltF3, cmClose,nil))),
    NewStatusDef(hcMineb, hcMineb,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~H~ilfe', kbF10, cmMenu,
      NewStatusKey('Gebe die Anzahl der Bomben an', kbAltF3, cmClose,nil))),
    NewStatusDef(hcKalender, hcKalender,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~H~ilfe', kbF10, cmMenu,
      NewStatusKey('Ein Kalender', kbAltF3, cmClose,nil))),
    NewStatusDef(hcPuzzle, hcPuzzle,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~H~ilfe', kbF10, cmMenu,
      NewStatusKey('Sortiere das Alphabet', kbAltF3, cmClose,nil))),
    NewStatusDef(hcINfo, hcInfo,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~H~ilfe', kbF10, cmMenu,
      NewStatusKey('Wer hat das Programm geschrieben?', kbAltF3, cmClose,nil))),
    NewStatusDef(succ(hcInfo),$FFFF ,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~F10~ Menu', kbF10, cmMenu,
      NewStatusKey('', kbAltF3, cmClose,
      NewStatusKey('', kbF5, cmZoom,
      NewStatusKey('', kbCtrlF5, cmResize,
      NewStatusKey('', kbF6, cmNext, nil)))))),
      nil))))))))))))));
end;

procedure PLabeledInputLine(d:PDialog;r:TRect;l:byte;AText:string;hc:word);
var h:TRect;
    Input:PInputLine;
begin
  h:=r;
  h.a.y:=h.b.y-14;
  new(Input,init(h,l));
  d^.insert(input);
  h:=r;
  h.b.y:=10+h.a.y;
  input^.helpctx:=hc;
  d^.insert(new(PLabel,init(h,Atext,input)));
end;

procedure TProg.Handleevent(var event: TEvent);
var myevent:boolean;

  procedure Calculator;
  begin
    DeskTop^.Insert(ValidView(New(PCalculator, Init)));
  end;

  procedure MineSweeper;
  var D:PDialog;
      r:TRect;
      data:array[0..2] of string[2];
      ende:word;
      x,y,b:byte;
      error:integer;
  begin
    r.assign(0,0,200,145);
    new(d,init(r,'Schwierigkeitsgrad'));
    r.assign(20,20,160,45);
    PLabeledInputLine(d,r,2,'X Gre:',hcMinex);
    r.assign(20,50,160,75);
    PLabeledInputLine(d,r,2,'Y Gre:',hcMineY);
    r.assign(20,80,160,105);
    PLabeledInputLine(d,r,2,'Bomben:',hcMineB);
    r.assign(100,120,170,135);
    d^.insert(new(PButton,init(r,'~C~ancel',cmCancel,bfnormal)));
    r.assign(20,120,90,135);
    d^.insert(new(PButton,init(r,'~O~k',cmOk,bfdefault)));
    data[0]:='20';
    data[1]:='20';
    data[2]:='60';
    d^.setdata(data);
    d^.options:=d^.options or ofcentered;
    d^.HelpCtx:=hcMineMenu;
    ende:=DeskTop^.ExecView(d);
    d^.getdata(data);
    dispose(d,done);
    if ende=cmok then begin
      val(data[0],x,error);
      if error=0 then val(data[1],y,error);
      if error=0 then val(data[2],b,error);
      if error=0 then DeskTop^.Insert(ValidView(New(PMineSweeper, Init(x,y,b))));
    end;
  end;

  procedure Puzzle;
  var
    P: PPuzzleWindow;
  begin
    P := New(PPuzzleWindow, Init);
{    P^.HelpCtx := hcPuzzle;}
    Desktop^.Insert(ValidView(P));
  end;

  procedure Calendar;
  var
    P: PCalendarWindow;
  begin
    P := New(PCalendarWindow, Init);
{    P^.HelpCtx := hcCalendar;}
    Desktop^.Insert(ValidView(P));
  end;

begin
  TProgram.Handleevent(event);
  if event.what=evcommand then begin
    myevent:=true;
    case event.command of
      cminfo:info;
      cmopen:Fileopen;
      cmchangedir:changedir;
      cmcalculator:calculator;
      cmpuzzle:puzzle;
      cmCalendar:Calendar;
      cmMineSweeper:MineSweeper;
      else myevent:=false;
    end;
    if myevent then clearevent(event) else write(^G);
  end;
end;

var MyApplication:TProg;

begin
  MyApplication.Init;
  MyApplication.Run;
  MyApplication.Done;
end.