unit TGVIEWS;
interface
uses graph,Objects,Drivers,TGDriver,TGMouse;
Type PPalette = ^TPalette;
     TPalette = string;

const cmValid            = 0  ;{Prft Gltigkeit einer View                }
      cmQuit             = 1  ;{Beendet das Programm                       }
      cmError            = 2  ;{Wird von keinem Objekt bearbeitet          }
      cmMenu             = 3  ;{Menauswahl                                }
      cmClose            = 4  ;{Schliet aktuelles Fenster                 }
      cmZoom             = 5  ;{Zoomt (oder verkleinert) Fenster           }
      cmResize           = 6  ;{Verndert Fenstergre                     }
      cmNext             = 7  ;{Bewegt letztes Fenster vor alle anderen    }
      cmPrev             = 8  ;{Bewegt erstes Fenster hinter alle anderen  }
      cmOK               =10  ;{OK wurde gedrckt                          }
      cmCancel           =11  ;{Dialogfenster wurde mit Cancel-            }
      cmYes              =12  ;{Yes-Schalter gedrckt                      }
      cmNo               =13  ;{No-Schalter gedrckt                       }
      cmDefault          =14  ;{Selektierter Schalter gedrckt             }
      cmReceivedFocus    =50  ;{Fokussiert View                            }
      cmReleasedFocus    =51  ;{Deaktiviert View                           }
      cmCommandSetChanged=52  ;{Befehlssatz verndert                      }
      cmScrollBarChanged =53  ;{Rollbalken mit neuem Wert                  }
      cmScrollBarClicked =54  ;{Rollbalken wurde angeklickt                }
      cmSelectWindowNum  =55  ;{Fenster ber Nummer whlbar                }
      cmRecordHistory    =56  ;{THistorylist soll Inhalt des Eingabefelds  }
      cmHelp             =57  ;
      cmCut              =58  ;
      cmCopy             =59;
      cmPaste            =60;
      cmUndo             =61;
      cmClear            =62;
      cmTile             =63;
      cmCascade          =64;
      cmListItemSelected =65;
      dmDragMove=$01 ;{View kann sich bewegen                              }
      dmDragGrow=$02 ;{View kann ihre Gre verndern                      }
      dmLimitLoX=$10 ;{Linke Seite kann nicht auerhalb Limits sein        }
      dmLimitLoY=$20 ;{Obergrenze kann nicht auerhalb Limits sein         }
      dmLimitHiX=$40 ;{Rechte Sein kann nicht auerhalb Limits sein        }
      dmLimitHiY=$80 ;{Untergrenze kann nicht auerhalb Limits sein        }
      dmLimitAll=$F0 ;{Keine Seite der View kann auerhalb Limits sein     }
      gfGrowLoX=$01 ;{Konstante Distanz von rechter Seite der Gruppe       }
      gfGrowLoY=$02 ;{Konstante Distanz von unterer Seite der Gruppe       }
      gfGrowHiX=$04 ;{Konstante Distanz von linker Seite der Gruppe        }
      gfGrowHiY=$08 ;{Konstante Distanz von oberer Seite der Gruppe        }
      gfGrowAll=$0F ;{Konstante Distanz von unterer rechter Ecke der Gruppe}
      gfGrowRel=$10 ;{Relative Gre zur Bildschirmgre bleibt            }
      hcNoContext = 0  ;{Neutraler Hilfekontext                            }
      hcDragging  = 1  ;{Objekt wird verlagert                             }
      scNormalShape = 0;
      ofSelectable =$0001;{Objekt kann selektiert werden                   }
      ofTopSelect  =$0002;{Selektion bewegt Objekt in den Vordergrund      }
      ofFirstClick =$0004;{Mausklick selektiert und startet Aktion         }
      ofFramed     =$0008;{Objekt hat sichtbaren Rahmen                    }
      ofPreProcess =$0010;{Fokussiertes Event vor Bearbeitung an Objekt    }
      ofPostProcess=$0020;{Fokussiertes Event nach Bearbeitung an Objekt   }
      ofBuffered   =$0040;{Gruppe mit Cache-Puffer                         }
      ofTileable   =$0080;{Objekte nebeneinander darstellbar               }
      ofCenterX    =$0100;{Objekt in X-Richtung zentriert                  }
      ofCenterY    =$0200;{Objekt in Y-Richtung zentriert                  }
      ofCentered   =$0300;{Objekt in X- und Y-Richtung zentriert           }
      sbLeftArrow = 0  ;{Horizontal-Balken linker Pfeil                    }
      sbRightArrow= 1  ;{Horizontal-Balken rechter Pfeil                   }
      sbPageLeft  = 2  ;{Horizontal-Balken linker Rollbereich              }
      sbPageRight = 3  ;{Horizontal-Balken rechter Rollbereich             }
      sbUpArrow   = 4  ;{Vertikal-Balken oberer Pfeil                      }
      sbDownArrow = 5  ;{Vertikal-Balken unterer Pfeil                     }
      sbPageUp    = 6  ;{Vertikal-Balken oberes Rollbereich                }
      sbPageDown  = 7  ;{Vertikal-Balken unteres Rollbereich               }
      sbIndicator = 8  ;{Positionsmarkierung                               }
      sfVisible  =$0001;{Objekt sichtbar                                   }
      sfCursorVis=$0002;{Objekt mit sichtbarem Cursor                      }
      sfCursorIns=$0004;{Blockcursor fr Insert-Modus                      }
      sfShadow   =$0008;{Objekt mit Schatten                               }
      sfActive   =$0010;{Objekt ist aktives Fenster oder zugehrig         }
      sfSelected =$0020;{Objekt wurde selektiert                           }
      sfFocused  =$0040;{Objekt ist fokussiert                             }
      sfDragging =$0080;{Objekt wird verlagert                             }
      sfDisabled =$0100;{Objekt ist deaktiviert                            }
      sfModal    =$0200;{Objekt ist modal                                  }
      sfExposed  =$0800;{Objekt ist mit Anwendung verknpft                }
      sfBuffered =$1000;{Objekt puffert seinen Bildschirmbereich zur Zeit  }
      wfMove  =$01 ;{Fenster kann mit Titelzeile bewegt werden             }
      wfGrow  =$02 ;{Fenstergre kann mit Maus verndert werden           }
      wfClose =$04 ;{Fensterrahmen enthlt Schliefeld                     }
      wfZoom  =$08 ;{Fensterrahmen enthlt Zoomfeld                        }
      wpBlueWindow= 0  ;{Gelb auf blau                                     }
      wpCyanWindow= 1  ;{Blau auf Cyan                                     }
      wpGrayWindow= 2  ;{Schwarz auf grau                                  }
      sccloseshape= 20 ;
      sczoomshape= 21 ;
      scgrowshape= 22 ;
      scmoveshape= 23 ;
      scScrollVerticalShape = 24;
      scScrollHorizontalShape = 25;
      scListViewerShape = 26;
      wnnonumber =0;
      shadowAttr=lightgray;
      ShadowSize:TPoint=(x:8;y:8);
      maxviewwidth=640;
      minWinSize:Tpoint=(x:4*8;y:2*8);
      errorattr:byte=15;
      focusedEvents:word=evkeyboard+evcommand;
      PositionalEvents:Word=evMouse;
      CommandSetChanged:Boolean=false;

type SelectMode = (NormalSelect, EnterSelect, LeaveSelect);
     TCommandSet = set of Byte;
     TDrawBuffer=Pointer;
     TVideoBuf=Pointer;
     TScrollChars = array[0..4] of Char;
     TTitleStr=String[80];

     PRect = ^TRect;
     TRect = object(Objects.TRect)
       procedure assignText(x1,y1,x2,y2:integer);
     end;

     PGroup = ^TGroup;
     PView = ^TView;
     TView = object(TObject)
               Owner: Pgroup;
               Next: PView;
               Origin: TPoint;
               Size: TPoint;
               GrowMode: Byte;
               DragMode: Byte;
               HelpCtx: Word;
               ShapeCtx: Word;
               PositionCtx: Word;
               State: Word;
               Options: Word;
               EventMask: Word;
               EndState: Word;
               Cursor : TPoint; {nur wegen Kompatibilitt zu TVision implementiert}
               constructor Init(var Bounds: TRect);
               constructor Load(Var S: TStream);
               destructor Done; virtual;
               procedure HandleEvent(var Event: TEvent); virtual;
               procedure CalcBounds(var Bounds: TRect; Delta: TPoint); virtual;
               procedure ChangeBounds(var Bounds: TRect); virtual;
               procedure ClearEvent(var Event: TEvent);
               function CommandEnabled(Command: Word): Boolean;
               function DataSize: Word; virtual;
               procedure DisableCommands(Commands: TCommandSet);
               procedure DragView(Event: TEvent; Mode: Byte;
                                  var Limits: TRect; MinSize, MaxSize: TPoint);
               procedure Draw; virtual;
               procedure DrawView;
               function CorrectViewPort:boolean;
               procedure EnableCommands(Commands: TCommandSet);
               procedure EndModal(Command:Word); virtual;
               function EventAvail: Boolean;
               function Execute: Word; virtual;
               function Exposed: Boolean;
               function Bedeckt: Boolean;
               procedure GetBounds(var Bounds: TRect);
               procedure GetClipRect(var Clip: TRect);
               function GetColor(Color: Word): Word;
               procedure GetCommands(var Commands: TCommandset);
               procedure GetData(var Rec); virtual;
               procedure GetEvent(var Event: TEvent); virtual;
               procedure GetExtent(var Extend: TRect);
               function GetHlpCtx:Word; virtual;
               function GetShapeCtx:Word; virtual;
               function GetPositionCtx:Word; virtual;
               function GetPalette: PPalette; virtual;
               procedure GetPeerViewPtr(var S: TStream; P:PView);
               function GetState(AState: Word): Boolean;
               procedure GrowTo(X,Y: Integer);
               procedure Hide;
               procedure KeyEvent(var Event: TEvent);
               procedure Locate(var Bounds: TRect);
               procedure MakeFirst;
               procedure MakeGlobal(Source: TPoint; var Dest: TPoint);
               procedure MakeLocal(Source: TPoint; var Dest: TPoint);
               function MouseEvent(var Event: TEvent; Mask: Word): Boolean;
               function MouseInView(Mouse: TPoint): Boolean;
               procedure MoveTo(X, Y: Integer);
               function NextView: PView;
               function Prev: PView;
               function PrevView: PView;
               procedure PutEvent(var Event: TEvent); virtual;
               procedure PutInFrontOf(Target: PView);
               procedure PutPeerViewPtr(var S: TStream; P: PView);
               procedure Select; virtual;
               procedure UnFocus; virtual;
               procedure Focus; virtual;
               procedure SetSelect; virtual;
               procedure SetUnFocus; virtual;
               procedure SetFocus; virtual;
               function selectpfad:boolean;
               function getfocused:PView; virtual;
               procedure SetBounds(var Bounds: TRect);
               procedure SetCommands(Commands: TCommandSet);
               procedure SetData(var Rec); virtual;
               procedure SetState(AState: Word; Enable: Boolean); virtual;
               procedure PutState(AState: Word; Enable: Boolean); virtual;
               procedure Show;
               procedure SizeLimits(var Min, Max: TPoint); virtual;
               procedure Store(var S: TStream);
               function TopView: PView;
               function Valid(Command: Word): Boolean; virtual;
               procedure WriteBuf(X, Y, W, H: Integer; var Buf );
               procedure WriteChar(X, Y: Integer; Ch: Char; Color: Byte; Count:Integer);
               procedure WriteLine(X, Y, W, H: Integer; Str:string; Color:byte);
               procedure WriteStr(X, Y: Integer; Str: String; Color: Byte);
               procedure Feld(x1,y1,x2,y2:integer;oben:boolean;boxcolor:word);
               procedure Indicator(x1,y1,x2,y2:integer;boxcolor:word);
               procedure ClearFeld(x1,y1,x2,y2:integer;boxcolor:word);
               procedure Arrow(x1,y1,x2,y2:integer;direction,boxcolor:word);
               procedure Ramen(x1,y1,x2,y2:integer;oben:boolean;boxcolor:word);
               procedure XorRamen(r:Trect;boxcolor:word);
               procedure CloseSymbol(x,y:integer;textcolor,boxcolor:word);
               procedure ZoomSymbol(x,y:integer;textcolor,boxcolor:word);
               procedure GrowSymbol(x,y:integer;textcolor,boxcolor:word);
               procedure Schreibefeld(x1,y1,x2,y2:integer;oben,zentriert:boolean;text:string;textcolor,boxcolor:word);
               procedure Schreiberamen(x1,y1,x2,y2:integer;oben,zentriert:boolean;text:string;textcolor,boxcolor:word);
               procedure Schreibe(x1,y1,x2,y2:integer;zentriert:boolean;text:string;textcolor:word);
               procedure SchreibeNormal(x,y:integer;text:string;c:byte);
               procedure Schreibeneu(x1,y1,x2,y2:integer;zentriert:boolean;text:string;textcolor:word);
               procedure schreibecursorneu(x,y:integer;ch:char;textcolor,boxcolor:word);
               procedure schreibecursor(x,y,curpos:integer;text:string;textcolor:word);
               procedure loschezeichen(x,y,count:integer;c:word);
               procedure schreibechar(x,y:integer;ch:char;textcolor:word);
               procedure Line(x1,y1,x2,breite:integer;boxcolor:word);
               procedure Linie(x1,y1,x2,y2:integer;color:word);
               procedure Fenster(x1,y1,x2,y2:integer;o,l,u,r:byte;boxcolor:word);
               procedure FensterRamen(x1,y1,x2,y2:integer;o,l,u,r:byte;boxcolor:word);
               procedure Schaltereckig(x,y:integer;oben:boolean;boxcolor,schaltercolor:word);
               procedure Schalterrund(x,y:integer;oben:boolean;boxcolor,schaltercolor:word);
               procedure showcursor;
               procedure hidecursor;
               procedure SetCursor(x,y:byte);
               {procedure Dummy;}
             end;

     PViewCollection = ^TViewCollection;
     TViewCollection = Object(TCollection)
                         procedure ForEachBackWard(Action: Pointer);
                       end;

     TGroup = object(TView)
                Last: PView;
                Current: PView;
                Phase: (phFocused, phPreProcess, phPostProcess);
                SubViews: PViewCollection;
                constructor Init(var Bounds: TRect);
                constructor Load(Var S: TStream);
                destructor Done; virtual;
                procedure ChangeBounds(var Bounds: TRect); virtual;
                function DataSize: Word; virtual;
                procedure Delete(P: PView);
                procedure Draw; virtual;
                procedure EndModal(Command: Word); virtual;
                procedure EventError(var Event: TEvent); virtual;
                function ExecView(P: PView): Word;
                function Execute: Word; virtual;
                function First: PView;
                function FirstThat(Test: Pointer):PView;
                procedure ForEach(Action: Pointer);
                procedure GetData(var Rec); virtual;
                function GetHlpCtx: Word; virtual;
                function GetShapeCtx:Word; virtual;
                function GetPositionCtx:Word; virtual;
                procedure GetSubViewPtr(var S: TStream; P:PView);
                procedure HandleEvent(var Event: TEvent); virtual;
                procedure Insert(P: PView);
                procedure InsertBefore(P, Target: PView);
                procedure PutSubViewPtr( var S: TStream; P: PView);
                procedure Redraw;
                procedure SelectNext(Forwards: Boolean);
                procedure searchfocus;
                procedure SetData(var Rec); virtual;
                procedure SetState(AState: Word; Enable:Boolean); virtual;
                procedure PutState(AState: Word; Enable:Boolean); virtual;
                procedure Store(var S: TStream);
                function Valid(Command: Word): Boolean; virtual;
                procedure Focus; virtual;
                procedure SetFocus; virtual;
                procedure UnFocus; virtual;
                procedure SetUnFocus; virtual;
                function getfocused:PView; virtual;
              end;

     PFrame = ^TFrame;
     TFrame = object(TView)
       rand: TRect;
       buffer: Pointer;
       correctrand:boolean;
       constructor Init(var Bound,arand: TRect);
       destructor done; virtual;
       constructor Load(var s:Tstream);
       procedure Draw; virtual;
       procedure DrawRamen;
       function Getpalette: PPalette; virtual;
       procedure HandleEvent(var Event: TEvent); virtual;
       procedure SetState(AState: Word; Enable:Boolean); virtual;
       procedure store(var s:TStream);
       function GetPositionCtx:Word; virtual;
       procedure DrawTitle;
     end;

     PScrollBar = ^TScrollBar;
     TScrollBar = object(TView)
       Value: Integer;
       Min: Integer;
       Max: Integer;
       PgStep: Integer;
       ArStep: Integer;
       OldPart:Byte;
       constructor Init(var Bounds: TREct);
       constructor Load(var S: TStream);
       procedure Draw; virtual;
       function GetPalette: PPAlette; virtual;
       procedure HandleEvent(var Event: TEvent); virtual;
       procedure ScrollDraw; virtual;
       function ScrollStep(Part: Integer): Integer; virtual;
       procedure SetParams(AValue, AMin, AMax, APgStep, AArStep: Integer);
       procedure SetRange(AMin, AMax: Integer);
       procedure SetStep(APgStep, AArStep: Integer);
       procedure SetValue(AValue: Integer);
       procedure Store(var S: TStream);
       function GetPositionCtx:Word; virtual;
     end;

     PListViewer = ^TListViewer;
     TListViewer = object(TView)
       HScrollBar: PScrollBar;
       VScrollBar: PScrollBar;
       NumCols: Integer;
       TopItem: Integer;
       Focused: Integer;
       Range: Integer;
       Zeilen: Integer;
       constructor Init(var Bounds: TRect; ANumCols: Word; AHScrollBar, AVScrollBar: PScrollBar);
       constructor Load(var S: TStream);
       procedure ChangeBounds(var Bounds: TRect); virtual;
       procedure Draw; virtual;
       procedure FocusItem(Item: Integer); virtual;
       function GetPalette: PPalette; virtual;
       function GetText(Item: Integer; MaxLen: Integer): String; virtual;
       function IsSelected(Item: Integer): Boolean; virtual;
       procedure HandleEvent(var Event: TEvent); virtual;
       procedure SelectItem(Item: Integer); virtual;
       procedure SetRange(ARange: Integer);
       procedure SetState(AState: Word; ENable: Boolean); virtual;
       procedure Store(var S:TStream);
     end;

     PScroller = ^TScroller;
     TScroller = object(TView)
       HScrollBar: PScrollBar;
       VScrollBar: PScrollBar;
       Delta: TPoint;
       Limit: TPoint;
       constructor Init(var Bounds: TRect; AHScrollBar, AVScrollBar: PScrollBar);
       constructor Load(var S: TStream);
       procedure ChangeBounds(var Bounds: TRect); virtual;
       function GetPalette: PPAlette; virtual;
       procedure HandleEvent(var Event: TEvent); virtual;
       procedure ScrollDraw; virtual;
       procedure ScrollTo(x,y: Integer);
       procedure SetLimit(x,y: Integer);
       procedure SetState(AState: Word; Enable: Boolean); virtual;
       procedure Store(var S: TStream);
     end;

     PWindow = ^TWindow;
     TWindow = object(TGroup)
       Flags: Byte;
       ZoomRect: TRect;
       Number: Integer;
       Palette: Integer;
       Frame: PFrame;
       Title: PString;
              constructor Init(var Bounds: TRect; ATitle: TTitlestr; ANumber: Integer);
       constructor Load(var S: TStream);
       destructor Done; virtual;
       procedure Close; virtual;
       function Getpalette: PPalette; virtual;
       function GetTitle(MaxSize: Integer): TTitleStr; virtual;
       Procedure SetTitle(ATitle: TTitleStr); virtual;
       procedure HandleEvent(var Event: TEvent); virtual;
       procedure InitFrame; virtual;
       procedure SetState(AState: Word; Enable: Boolean); virtual;
       procedure SizeLimits(var Min,Max: TPoint); virtual;
       function StandardScrollBar(AOptions: Word): PScrollBar;
       procedure Store(var S: TStream);
       procedure Zoom; virtual;
       procedure select; virtual;
       procedure setselect; virtual;
     end;

procedure disposestr(p:Pstring);
function newstr(s:string):PString;
function Message(Receiver:PView; What, Command: Word; InfoPtr: Pointer):Pointer;
procedure RegisterViews;
implementation
type PPeerViewPtr = ^TPeerViewPtr;
     TPeerViewPtr = record
       last:PPeerViewPtr;
       Number:Integer;
       SubView:PView;
       Ptr:PView;
     end;
const CurCommands:TCommandSet=[0..255];
const AktPeerViewPtr:PPeerViewPtr=nil;


procedure disposestr(p:Pstring);
begin
  if p<>nil then freemem(p,succ(length(p^)));
end;

function newstr(s:string):PString;
var hps:pointer;
begin
  if length(s)=0 then newstr:=nil else begin
    getmem(hps,succ(length(s)));
    move(s[0],hps^,succ(length(s)));
    newstr:=hps;
  end;
end;

function Message(Receiver:PView; What, Command: Word; InfoPtr: Pointer):Pointer;
var Event:Tevent;
begin
  event.what:=what;
  event.command:=command;
  event.infoptr:=infoptr;
  if receiver<>nil then begin
    receiver^.handleevent(event);
    if event.what=evnothing then message:=event.infoptr
    else message:=nil;
  end else message:=nil;
end;

procedure RegisterViews;
const RView:TStreamRec = (
        ObjType:101;
        VmtLink: Ofs(TypeOf(TView)^);
        Load: @TView.Load;
        Store: @TView.Store);
      RFrame:TStreamRec = (
        ObjType:102;
        VmtLink: Ofs(TypeOf(TFrame)^);
        Load: @TFrame.Load;
        Store: @TFrame.Store);
      RScrollBar:TStreamRec = (
        ObjType:103;
        VmtLink: Ofs(TypeOf(TScrollBar)^);
        Load: @TScrollBar.Load;
        Store: @TScrollBar.Store);
      RScroller:TStreamRec = (
        ObjType:104;
        VmtLink: Ofs(TypeOf(TScroller)^);
        Load: @TScroller.Load;
        Store: @TScroller.Store);
      RListViewer:TStreamRec = (
        ObjType:105;
        VmtLink: Ofs(TypeOf(TListViewer)^);
        Load: @TListViewer.Load;
        Store: @TListViewer.Store);
      RGroup:TStreamRec = (
        ObjType:106;
        VmtLink: Ofs(TypeOf(TGroup)^);
        Load: @TGroup.Load;
        Store: @TGroup.Store);
      RWindow:TStreamRec = (
        ObjType:107;
        VmtLink: Ofs(TypeOf(TWindow)^);
        Load: @TWindow.Load;
        Store: @TWindow.Store);
begin
  RegisterType(RView);
  RegisterType(RFrame);
  RegisterType(RScrollBar);
  RegisterType(RScroller);
  RegisterType(RListViewer);
  RegisterType(RGroup);
  RegisterType(RWindow);
end;

procedure TRect.assignText(x1,y1,x2,y2:integer);
begin
  Objects.TRect.assign(x1*8,y1*10,x2*8,y2*10);
end;

constructor TView.Init(var Bounds: TRect);
begin
  Owner    :=nil;
  Next     :=nil;
  Origin   :=Bounds.A;
  Size.X   :=Bounds.B.X - Bounds.A.X;
  Size.Y   :=Bounds.B.Y - Bounds.A.Y;
  GrowMode :=0;
  DragMode :=dmLimitLoY;
  HelpCtx  :=hcNoContext;
  ShapeCtx :=scNormalShape;
  PositionCtx :=scNormalShape;
  State    :=sfvisible;
  Options  :=0;
  EventMask:=evMouseDown + evKeyDown + evCommand;
end;

constructor TView.Load(Var S: TStream);
begin
  getpeerviewptr(s,next);
  s.read(origin,sizeof(origin));
  s.read(size,sizeof(size));
  s.read(GrowMode,sizeof(growmode));
  s.read(DragMode,sizeof(dragmode));
  s.read(HelpCtx,sizeof(HelpCtx));
  s.read(ShapeCtx,sizeof(ShapeCtx));
  s.read(PositionCtx,sizeof(PositionCtx));
  s.read(State,sizeof(State));
  s.read(Options,sizeof(Options));
  s.read(EventMask,sizeof(EventMask));
end;

destructor TView.Done;
begin
  if owner<>nil then owner^.delete(@self);
end;

procedure TView.HandleEvent(var Event: TEvent);
begin
  if (event.what=evmousedown) and
     (not selectpfad) and
     (not GetState(sfdisabled)) and
     (options and ofSelectable>0) then
   Focus;
end;

procedure TView.CalcBounds(var Bounds: TRect; Delta: TPoint);
begin
end;

procedure TView.ChangeBounds(var Bounds: TRect);
begin
  setbounds(bounds);
end;

procedure TView.ClearEvent(var Event: TEvent);
begin
  event.what:=evnothing;
  event.infoptr:=@self;
end;

function TView.CommandEnabled(Command: Word): Boolean;
begin
  if command>255 then Commandenabled:=true
  else commandenabled:=command in CurCommands;
end;

function TView.DataSize: Word;
begin
  DataSize:=0;{eigentlich abstract}
end;

procedure TView.DisableCommands(Commands: TCommandSet);
begin
  Curcommands:=curcommands-commands;
  commandsetchanged:=true;
end;

procedure TView.DragView(Event: TEvent; Mode: Byte;
                   var Limits: TRect; MinSize, MaxSize: TPoint);
var r,g,oldg:trect;
    delta,drg:TPoint;
    color:word;
begin
  if event.what and evmousedown>0 then begin
    if mode and dmDragMove >0 then begin
      setviewport(0,0,pred(screenwidth),pred(screenheight),false);
      color:=getcolor(3);
      getbounds(r);
      if owner<>nil then begin
        owner^.makeglobal(r.a,g.a);
        owner^.makeglobal(r.b,g.b);
{        owner^.makeglobal(limits.a,limits.a);
        owner^.makeglobal(limits.b,limits.b);}
      end else g:=r;
      oldg:=g;
      delta.x:=event.where.x-g.a.x;
      delta.y:=event.where.y-g.a.y;
      drg.x:=r.a.x-g.a.x;
      drg.y:=r.a.y-g.a.y;
      xorramen(g,color);
      repeat
        repeat
          getmouseevent(event);
        until event.what<>evnothing;
        if event.what and evmousemove>0 then begin
          g.a.x:=event.where.x-delta.x;
          g.a.y:=event.where.y-delta.y;
          g.b.x:=g.a.x+(r.b.x-r.a.x);
          g.b.y:=g.a.y+(r.b.y-r.a.y);
          {if (g.a.x<limits.a.x) or (g.a.y<limits.a.y) or
             (g.a.x>limits.B.x) or (g.a.y>limits.B.y) then g:=oldg;}
          {if (event.where.x<limits.a.x) or (event.where.x>limits.b.x) then begin
            g.a.x:=oldg.a.x;
            g.b.x:=oldg.b.x;
          end;
          if (event.where.y<limits.a.y) or (event.where.y>limits.b.y) then begin
            g.a.y:=oldg.a.y;
            g.b.y:=oldg.b.y;
          end;}
          if (g.a.x<limits.a.x) or (g.b.x>limits.b.x) then begin
            g.a.x:=oldg.a.x;
            g.b.x:=oldg.b.x;
          end;
          if (g.a.y<limits.a.y) or (g.b.y>limits.b.y) then begin
            g.a.y:=oldg.a.y;
            g.b.y:=oldg.b.y;
          end;
          if (not g.equals(oldg)) then begin
            xorramen(oldg,color);
            oldg:=g;
            xorramen(g,color);
          end;
        end;
      until event.what and evmouseup>0;
      xorramen(g,color);
      r.a.x:=drg.x+g.a.x;
      r.a.y:=drg.y+g.a.y;
      r.b.x:=drg.x+g.b.x;
      r.b.y:=drg.y+g.b.y;
      SetBounds(r);
      Owner^.drawview;
    end else begin

    end;
  end else begin

  end;
end;

procedure TView.Draw;
begin
  abstract;
end;

procedure TView.DrawView;
begin
  if exposed and Getstate({sfexposed+}sfvisible) then begin
    if correctviewport then draw;
  end;
end;

function TView.CorrectViewPort:boolean;
var r,h,b:trect;
    oldown,own:PGroup;
begin
  own:=owner;
  getbounds(R);
  while own<>nil do begin
    own^.getbounds(h);
    r.move(h.a.x,h.a.y);
    if r.b.x>h.b.x then r.b.x:=h.b.x;
    if r.b.y>h.b.y then r.b.y:=h.b.y;
    oldown:=own;
    own:=own^.owner;
  end;
  oldown^.getbounds(h);
  b.a.x:=0;b.a.y:=0;
  b.b.x:=pred(screenwidth);b.b.y:=pred(screenheight);
  CorrectViewport:=h.equals(b);
  if r.a.x<0 then r.a.x:=0;
  if r.a.y<0 then r.a.y:=0;
  if r.b.y>=screenheight then r.b.y:=pred(screenheight);
  if r.b.x>=screenwidth then r.b.x:=pred(screenwidth);
  setviewport(r.a.x,r.a.y,r.b.x,r.b.y,true{false});
end;

{procedure TView.DrawViewFast;
var r:trect;
    ViewPort:ViewPortType;
begin                     sfexposed+
  if exposed and Getstate(sfvisible) then begin
    getViewsettings(ViewPort);
    getbounds(r);
    with Viewport do setviewport(x1+r.a.x,y1+r.a.y,x1+r.b.x,y1+r.b.y,true);
    draw;
    with Viewport do setviewport(x1,y1,x1,y1,clip);
  end;
end;
}

procedure TView.EnableCommands(Commands: TCommandSet);
begin
  CurCommands:=CurCommands+Commands;
  commandsetchanged:=true;
end;

procedure TView.EndModal(Command:Word);
begin
  endstate:=command;
end;

function TView.EventAvail: Boolean;
begin
  EventAvail:=true; {Mu noch verbessert werden}
end;

function TView.Execute: Word;
begin
  abstract;
end;

function TView.Exposed: Boolean;
begin
  exposed:=true; {Mu noch berichtigt werden!}
end;

function TView.Bedeckt: Boolean;
var r,b:trect;
    n:word;
    deckung:boolean;
begin
  if (owner<>nil) and (owner^.subviews<>nil) then begin
    getbounds(r);
    n:=succ(owner^.subviews^.indexof(@self)); {Nur die hher gelegenen knnen mich bedecken}
    deckung:=false;
    while (not deckung) and (n<owner^.subviews^.count) do begin
      PView(owner^.subviews^.at(n))^.getbounds(b);
      b.Intersect(r);
      deckung:=(b.a.x<>b.b.x) and (b.a.y<>b.b.y);
      inc(n);
    end;
    bedeckt:=deckung;
  end else bedeckt:=false;
end;

procedure TView.GetBounds(var Bounds: TRect);
begin
  bounds.a:=origin;
  bounds.b.x:=origin.x+size.x;
  bounds.b.y:=origin.y+size.y;
end;

procedure TView.GetClipRect(var Clip: TRect);
begin
  clip.a:=origin; {Mu noch verbessert werden !}
  clip.b.x:=origin.x+size.x;
  clip.b.y:=origin.y+size.y;
end;

function TView.GetColor(Color: Word): Word;
var high,low:byte;
begin
  if getpalette<>nil then begin
    if hi(color)>length(getpalette^) then
      high:=hi(color)
    else begin
      if hi(color)=0 then high:=0 else high:=byte(getpalette^[hi(color)]);
    end;
    if lo(color)>length(getpalette^) then
      low:=lo(color)
    else begin
      if lo(color)=0 then low:=0 else low:=byte(getpalette^[lo(color)]);
    end;
    if owner<>nil then getcolor:=owner^.getcolor(high*256+low)
    else getcolor:=high*256+low;
  end else begin
    if owner<>nil then getcolor:=owner^.getcolor(color) else getcolor:=color;
  end;
end;

procedure TView.GetCommands(var Commands: TCommandset);
begin
  commands:=CurCommands;
end;

procedure TView.GetData(var Rec);
begin
  {abstract;}
end;

procedure TView.GetEvent(var Event: TEvent);
begin
  if owner<>nil then owner^.getevent(event) else event.what:=evnothing;
end;

procedure TView.GetExtent(var Extend: TRect);
begin
  extend.a.x:=0;extend.a.y:=0;
  extend.b:=size;
end;

function TView.GetHlpCtx:Word;
begin
  gethlpctx:=helpctx;
end;

function TView.GetPositionCtx:Word;
begin
  getpositionctx:=positionctx;
end;


function Tview.GetShapeCtx:Word;
begin
  getshapectx:=shapectx;
end;

function TView.GetPalette: PPalette;
begin
  GetPalette:=nil;
end;

procedure TView.GetPeerViewPtr(var S: TStream; P:PView);
var PeerViewPtr:PPeerViewPtr;
begin
  new(PeerViewPtr);
  with PeerViewPtr^ do begin
    ptr:=p;
    s.read(number,sizeof(Integer));
    subview:=@self;
    last:=aktpeerviewptr;
    aktpeerviewptr:=peerViewPtr;
  end;
end;

function TView.GetState(AState: Word): Boolean;
begin
  getstate:=(state and astate)=astate;
end;

procedure TView.GrowTo(X,Y: Integer);
begin
  inc(size.x,x);
  inc(size.y,y);
end;

procedure TView.Hide;
begin
  SetState(sfvisible,false);
end;

procedure TView.KeyEvent(var Event: TEvent);
begin
  repeat
    getevent(event);
  until event.what=evkeydown;
end;

procedure TView.Locate(var Bounds: TRect);
var min,max:tpoint;
begin
  sizelimits(min,max);
  if bounds.b.x<min.x then bounds.b.x:=min.x;
  if bounds.b.y<min.y then bounds.b.y:=min.y;
  if bounds.b.x>max.x then bounds.b.x:=max.x;
  if bounds.b.y>max.y then bounds.b.y:=max.y;
  changebounds(bounds);
end;

procedure TView.MakeFirst;
begin
  if (owner<>nil) then PutInFrontOf(Owner^.Last);
end;

procedure TView.MakeGlobal(Source: TPoint; var Dest: TPoint);
begin
  if owner<>nil then owner^.makeglobal(source,source);
  dest.x:=source.x+origin.x;
  dest.y:=source.y+origin.y;
end;

procedure TView.MakeLocal(Source: TPoint; var Dest: TPoint);
begin
  if owner<>nil then owner^.makelocal(source,source);
  dest.x:=source.x-origin.x;
  dest.y:=source.y-origin.y;
end;

function TView.MouseEvent(var Event: TEvent; Mask: Word): Boolean;
begin
  repeat
    getevent(event);
  until (event.what and evMouse)>0;
  Mouseevent:=(event.what<>evmouseup) and ((event.what and mask)>0);
end;

function TView.MouseInView(Mouse: TPoint): Boolean;
var Local:TPoint;
begin
  makelocal(Mouse,Local);
  MouseInView:=(Local.x>=0) and (Local.y>=0) and
               (Local.x<=size.x) and (Local.y<=size.y);
end;

procedure TView.MoveTo(X, Y: Integer);
begin
  origin.x:=x;
  origin.y:=y;
end;

function TView.NextView: PView;
begin
  if owner^.last=@self then nextview:=nil else nextview:=next;
end;

function TView.Prev: PView;
var before:PView;
begin
  before:=next;
  while (before^.next<>@self) and (before<>@self) do before:=before^.next;
  prev:=before;
end;

function TView.PrevView: PView;
begin
  if owner^.first=@self then prevView:=nil else prevview:=prev;
end;

procedure TView.PutEvent(var Event: TEvent);
begin
  owner^.putevent(event);
end;

procedure TView.PutInFrontOf(Target: PView);
var myoldindex,mytargetindex:integer;
    ABedeckt:boolean;
begin
  {Nummer 0= unterstes in Z Ordnung=als erstes eingefgt/dargestellt/berdeckt}
  {Z-Ordung= ForEachBackWard / umgekehrte Z-Ordung= ForEach}
  {Index der neuen Position eins grer als TargetIndex}
  if (owner^.Subviews^.count>1) and (target<>nil) then begin       {Nur wenn mehr als eine Subview da ist hat der Befehl Sinn}
    myoldindex:=owner^.Subviews^.IndexOf(@self);
    mytargetindex:=succ(owner^.Subviews^.IndexOf(Target)); {Meine neue Position}
    if (Target<>@self) and
       (myoldindex<>mytargetindex) and
       (mytargetindex<>0) then begin
      ABedeckt:=bedeckt;
      if ABedeckt then setstate(sfvisible,false);
      prev^.next:=next;
      owner^.subviews^.atdelete(myoldindex);               {Jetzt verschwinde ich Next und Last werden neu eingestellt}
      owner^.Subviews^.AtInsert(succ(owner^.Subviews^.IndexOf(Target)),@self);  {Und werde wieder eingefgt}
      next:=target^.next;                        {Mein nchster ist der alte nchste von Target}
      Target^.next:=@self;                       {Ich bin fr Target der Nchste}
      if owner^.Subviews^.IndexOf(@self)=pred(owner^.subviews^.count)    {wenn ich letzter bin}
      then owner^.last:=@self;                   {dann zeigt last auf mich}
      if ABedeckt then setstate(sfvisible,true);
    end;
  end;

    {Nur ZU TESTZWECKEN
  if owner<>nil then begin
    owner^.dummy;
    If owner^.current<>nil then owner^.current^.dummy;
    If owner^.last<>nil then owner^.last^.dummy;
  end;}

end;


procedure TView.PutPeerViewPtr(var S: TStream; P: PView);
var Index:Integer;
begin
  Index:=owner^.subviews^.IndexOf(p);
  s.write(index,sizeof(integer));
end;

procedure TView.SetBounds(var Bounds: TRect);
begin
  Origin   :=Bounds.A;
  Size.X   :=Bounds.B.X - Bounds.A.X;
  Size.Y   :=Bounds.B.Y - Bounds.A.Y;
end;

procedure TView.SetCommands(Commands: TCommandSet);
begin
  CurCommands:=Commands;
  commandsetchanged:=true;
end;

procedure TView.SetData(var Rec);
begin
  {mu leer bleiben}
end;

procedure TView.SetState(AState: Word; Enable: Boolean);
var oldstate:word;
begin
  oldstate:=state;
  if enable then begin
    state:=state or astate;
    if (((astate and sfvisible)>0) and ((oldstate and sfvisible)=0))
    then drawview;
    if (((astate and sffocused)>0) and ((oldstate and sffocused)=0))
    then message(owner,evBroadcast,cmReceivedFocus,@self);
  end else begin
    state:=state and (not astate);
    if (((state and sfvisible)=0) and ((oldstate and sfvisible)>0))
    then begin
      if correctviewport then draw;
    end;
    if (((state and sffocused)=0) and ((oldstate and sffocused)>0))
    then message(owner,evBroadcast,cmReleasedFocus,@self);
  end;
end;

procedure TView.PutState(AState: Word; Enable: Boolean);
begin
  if enable then state:=state or astate
  else state:=state and (not astate)
end;

procedure TView.Show;
begin
  setstate(sfvisible,true);
end;

procedure TView.SizeLimits(var Min, Max: TPoint);
begin
  min:=minwinsize;
  max:=size;
end;

procedure TView.Store(var S: TStream);
begin
  putpeerviewptr(s,next);
  s.write(origin,sizeof(origin));
  s.write(size,sizeof(size));
  s.write(GrowMode,sizeof(growmode));
  s.write(DragMode,sizeof(dragmode));
  s.write(HelpCtx,sizeof(HelpCtx));
  s.write(ShapeCtx,sizeof(ShapeCtx));
  s.write(PositionCtx,sizeof(PositionCtx));
  s.write(State,sizeof(State));
  s.write(Options,sizeof(Options));
  s.write(EventMask,sizeof(EventMask));
end;

function TView.TopView: PView;
begin
  if Getstate(sfmodal) then topview:=@self else TopView:=owner^.TopView;
end;

function TView.Valid(Command: Word): Boolean;
begin
  valid:=true;
end;

procedure TView.showcursor;{Nur zur Kompatibilitt mit TVision implementiert}
begin
end;

procedure TView.hidecursor;
begin
end;

procedure TView.SetCursor(x,y:byte);
begin
end;

procedure TView.WriteBuf(X, Y, W, H: Integer; var Buf );
begin
  setviewport(x,y,x+w,y+h,true);
  hidemouse;
  putimage(x,y,buf,normalput);
  showmouse;
  setviewport(0,0,pred(screenWidth),pred(Screenheight),false);
end;

procedure TView.WriteChar(X, Y: Integer; Ch: Char; Color: Byte; Count:Integer);
var col:byte;
    n:byte;
begin
  col:=lo(getcolor(color));
  setfillstyle(solidfill,col shr 4);
  setcolor(col and $F);
  hidemouse;
  bar(x,y,x+8*count,y+8);
  for n:=1 to count do outtextxy(x+8*n,y,ch);
  showmouse;
end;

procedure TView.WriteLine(X, Y, W, H: Integer; Str:string; Color:byte);
var col:byte;
    n:byte;
begin
  col:=lo(getcolor(color));
  setfillstyle(solidfill,col shr 4);
  setcolor(col and $F);
  hidemouse;
  bar(x,y,x+w,y+h);
  for n:=1 to h do outtextxy(x,y+8*n,str);
  showmouse;
end;

procedure TView.WriteStr(X, Y: Integer; Str: String; Color: Byte);
var col:byte;
    n:byte;
begin
  col:=lo(getcolor(color));
  setfillstyle(solidfill,col shr 4);
  setcolor(col and $F);
  hidemouse;
  bar(x,y,x+length(str)*8,y+8);
  outtextxy(x,y,str);
  showmouse;
end;

procedure TView.Feld(x1,y1,x2,y2:integer;oben:boolean;boxcolor:word);
{hi(boxcolor) shr 4 = Not Used
 hi(boxcolor) and $F= Hintergrund
 lo(boxcolor) shr 4 = Ramen hell
 lo(boxcolor) and $F= Ramen dunkel}
begin
  if oben then setcolor(lo(boxcolor) shr 4) else setcolor(lo(boxcolor) and $F);
  graph.moveto(x2,y1);
  hidemouse;
  lineto(x1,y1);
  lineto(x1,y2);
  if oben then setcolor(lo(boxcolor) and $F) else setcolor(lo(boxcolor) shr 4);
  graph.moveto(succ(x1),y2);
  lineto(x2,y2);
  lineto(x2,succ(y1));
  setfillstyle(solidfill,hi(boxcolor) and $F);
  bar(succ(x1),succ(y1),pred(x2),pred(y2));
  showmouse;
end;

procedure TView.Indicator(x1,y1,x2,y2:integer;boxcolor:word);
var r:byte;
begin
  hidemouse;
  feld(x1,y1,x2,y2,true,boxcolor);
  setcolor(lo(boxcolor) and $F);
  r:=(y2-y1) div 6;
  x1:=(x1+x2) div 2;
  y1:=(y1+y2) div 2;
  arc(x1,y1,225,45,r);
  setcolor(lo(boxcolor) shr 4);
  arc(x1,y1,45,225,r);
  showmouse;
end;

procedure TView.ClearFeld(x1,y1,x2,y2:integer;boxcolor:word);
begin
  hidemouse;
  setfillstyle(solidfill,hi(boxcolor) and $F);
  bar(x1,y1,x2,y2);
  showmouse;
end;

procedure TView.Arrow(x1,y1,x2,y2:integer;direction,boxcolor:word);
var m:integer;
begin
  hidemouse;
  feld(x1,y1,x2,y2,true,boxcolor);
  x1:=x1+2;
  x2:=x2-2;
  y1:=y1+2;
  y2:=y2-2;
  case Direction of
    sbLeftArrow:begin
      setcolor(lo(boxcolor) and $F);{grau0}
      m:=(y1+y2) div 2;
      graph.moveto(x1,m);
      lineto(x2,y1);
      setcolor(lo(boxcolor) shr 4); {grau2}
      lineto(x2,y2);
      lineto(x1,m);
    end;
    sbRightArrow:begin
      setcolor(lo(boxcolor) and $F);
      m:=(y1+y2) div 2;
      graph.moveto(x2,m);
      lineto(x1,y1);
      lineto(x1,y2);
      setcolor(lo(boxcolor) shr 4); {grau2}
      lineto(x2,m);
    end;
    sbUpArrow:begin
      setcolor(lo(boxcolor) and $F);
      m:=(x1+x2) div 2;
      graph.moveto(m,y1);
      lineto(x1,y2);
      setcolor(lo(boxcolor) shr 4); {grau2}
      lineto(x2,y2);
      lineto(m,y1);
    end;
    sbDownArrow:begin
      setcolor(lo(boxcolor) and $F);
      m:=(x1+x2) div 2;
      graph.moveto(m,y2);
      lineto(x1,y1);
      lineto(x2,y1);
      setcolor(lo(boxcolor) shr 4); {grau2}
      lineto(m,y2);
    end;
  end;

  showmouse;
end;

procedure TView.Ramen(x1,y1,x2,y2:integer;oben:boolean;boxcolor:word);
{hi(boxcolor) shr 4 = Not Used
 hi(boxcolor) and $F= Hintergrund
 lo(boxcolor) shr 4 = Ramen hell
 lo(boxcolor) and $F= Ramen dunkel}
begin
  if oben then setcolor(lo(boxcolor) shr 4) else setcolor(lo(boxcolor) and $F);
  graph.moveto(x2,y1);
  hidemouse;
  lineto(x1,y1);
  lineto(x1,y2);
  if oben then setcolor(lo(boxcolor) and $F) else setcolor(lo(boxcolor) shr 4);
  graph.moveto(succ(x1),y2);
  lineto(x2,y2);
  lineto(x2,succ(y1));
  showmouse;
end;

procedure TView.XorRamen(r:Trect;boxcolor:word);
{lo(boxcolor) shr 4 = Ramen hell
 lo(boxcolor) and $F= Ramen dunkel}
begin
  hidemouse;
  setcolor(lo(boxcolor) shr 4);
  setwritemode(xorput);
  graph.moveto(r.b.x,r.a.y);
  lineto(r.a.x,r.a.y);
  lineto(r.a.x,r.b.y);
  setcolor(lo(boxcolor) and $F);
  graph.moveto(succ(r.a.x),r.b.y);
  lineto(r.b.x,r.b.y);
  lineto(r.b.x,succ(r.a.y));
  setwritemode(normalput);
  showmouse;
end;

procedure TView.Line(x1,y1,x2,breite:integer;boxcolor:word);
{hi(boxcolor) shr 4 = Not Used
 hi(boxcolor) and $F= Hintergrund
 lo(boxcolor) shr 4 = Ramen hell
 lo(boxcolor) and $F= Ramen dunkel}
begin
  setcolor(lo(boxcolor) shr 4);
  hidemouse;
  graph.line(x1,y1,x2,y1);
  setcolor(lo(boxcolor) and $F);
  graph.line(x1,y1+breite,x2,y1+breite);
  setfillstyle(solidfill,hi(boxcolor) and $F);
  bar(x1,succ(y1),x2,pred(y1+breite));
  showmouse;
end;

procedure TView.Linie(x1,y1,x2,y2:integer;color:word);
begin
  hidemouse;
  setcolor(color shr 4);
  Graph.line(x1,y1,x2,y2);
  setcolor(color and $F);
  Graph.line(succ(x1),y1,succ(x2),y2);
  showmouse;
end;

procedure TView.Fenster(x1,y1,x2,y2:integer;o,l,u,r:byte;boxcolor:word);
{hi(boxcolor) shr 4 = Not Used
 hi(boxcolor) and $F= Hintergrund
 lo(boxcolor) shr 4 = Ramen hell
 lo(boxcolor) and $F= Ramen dunkel}
begin
  setfillstyle(solidfill,hi(boxcolor) and $F);
  hidemouse;
  bar(succ(x1),succ(y1),pred(x2),pred(y2));
  setcolor(lo(boxcolor) shr 4);
  graph.moveto(x2,y1);
  lineto(x1,y1);
  lineto(x1,y2);
  graph.moveto(x1+l+2,pred(y2-u));
  lineto(pred(x2-r),pred(y2-u));
  lineto(pred(x2-r),y1+o+2);
  setcolor(lo(boxcolor) and $F);
  graph.moveto(pred(x2-r),succ(y1+o));
  lineto(succ(x1+l),succ(y1+o));
  lineto(succ(x1+l),pred(y2-u));
  graph.moveto(succ(x1),y2);
  lineto(x2,y2);
  lineto(x2,succ(y1));
  showmouse;
end;

procedure TView.FensterRamen(x1,y1,x2,y2:integer;o,l,u,r:byte;boxcolor:word);
{hi(boxcolor) shr 4 = Not Used
 hi(boxcolor) and $F= Hintergrund
 lo(boxcolor) shr 4 = Ramen hell
 lo(boxcolor) and $F= Ramen dunkel}
begin
  hidemouse;
  setcolor(lo(boxcolor) shr 4);
  graph.moveto(x2,y1);
  lineto(x1,y1);
  lineto(x1,y2);
  graph.moveto(x1+l+2,pred(y2-u));
  lineto(pred(x2-r),pred(y2-u));
  lineto(pred(x2-r),y1+o+2);
  setcolor(lo(boxcolor) and $F);
  graph.moveto(pred(x2-r),succ(y1+o));
  lineto(succ(x1+l),succ(y1+o));
  lineto(succ(x1+l),pred(y2-u));
  graph.moveto(succ(x1),y2);
  lineto(x2,y2);
  lineto(x2,succ(y1));
  showmouse;
end;


  procedure splitstr(ein:string;var alles,normal,tasten:string);
  var posi:byte;
      modus:boolean;
  begin
    alles:='';
    normal:='';
    tasten:='';
    if length(ein)>0 then begin
      modus:=true;
      for posi:=1 to length(ein) do begin
        if '~'=ein[posi] then modus:=not modus
        else begin
          if modus then begin
            alles:=alles+ein[posi];
            normal:=normal+ein[posi];
            tasten:=tasten+' ';
          end else begin
            alles:=alles+ein[posi];
            normal:=normal+' ';
            tasten:=tasten+ein[posi];
          end;
        end;
      end;
    end;
  end;

procedure TView.CloseSymbol(x,y:integer;textcolor,boxcolor:word);
var x1,y1:integer;
begin
  feld(x,y,x+10,y+10,true,boxcolor);
  setcolor(lo(textcolor) and $F);
  inc(x);inc(y);
  for x1:=0 to 2 do for y1:=0 to 2 do
  Graph.line(x+x1*4,y+y1*4,x+4,y+4);
end;

procedure TView.ZoomSymbol(x,y:integer;textcolor,boxcolor:word);
var x1,y1,x2,y2:integer;
begin
  feld(x,y,x+10,y+10,true,boxcolor);
  setcolor(lo(textcolor) shr 4);
  outtextxy(x+2,y+2,char(18));
  setcolor(lo(textcolor) and $F);
  outtextxy(succ(x),succ(y),char(18));
end;

procedure TView.GrowSymbol(x,y:integer;textcolor,boxcolor:word);
var x1,y1,x2,y2:integer;
begin
  feld(x,y,x+10,y+10,true,boxcolor);
  setfillstyle(solidfill,lo(textcolor) and $F);
  bar(succ(x),succ(y),x+7,y+7);
end;

procedure TView.Schreibefeld(x1,y1,x2,y2:integer;oben,zentriert:boolean;text:string;textcolor,boxcolor:word);
begin
  feld(x1,y1,x2,y2,oben,boxcolor);
  if zentriert then schreibe(x1,y1,x2,y2,zentriert,text,textcolor)
  else schreibe(x1+5,y1+2,x2,y2,zentriert,text,textcolor);
end;

procedure TView.SchreibeNormal(x,y:integer;text:string;c:byte);
begin
  Hidemouse;
  setcolor(c);
  outtextxy(x,y,text);
  ShowMouse;
end;

procedure TView.Schreiberamen(x1,y1,x2,y2:integer;oben,zentriert:boolean;text:string;textcolor,boxcolor:word);
begin
  ramen(x1,y1,x2,y2,oben,boxcolor);
  if zentriert then schreibeneu(x1,y1,x2,y2,zentriert,text,textcolor)
  else schreibeneu(x1+5,y1+2,x2,y2,zentriert,text,textcolor);
end;

procedure TView.Schreibe(x1,y1,x2,y2:integer;zentriert:boolean;text:string;textcolor:word);
{hi(textcolor) shr 4 = Hintergrund hervorgehoben
 hi(textcolor) and $F= Text hervorgehoben
 lo(textcolor) shr 4 = Hintergrund normal
 lo(textcolor) and $F= Text normal}
var xcor,ycor:integer;
    hs:string;
    alles,normal,tasten:string;
    c:char;
begin
  splitstr(text,alles,normal,tasten);
  setcolor(hi(textcolor) shr 4);
  if zentriert then begin
    xcor:=succ(x1+(((x2-x1)-(length(alles)*8)-2) div 2));
    ycor:=y1+((y2-y1-6) div 2);
  end else begin
    xcor:=x1;
    ycor:=y1;
  end;
  hidemouse;
  outtextxy(succ(xcor),succ(ycor),alles);
  setcolor(lo(textcolor) and $F);
  outtextxy(xcor,ycor,normal);
  setcolor(hi(textcolor) and $F);
  outtextxy(xcor,ycor,tasten);
  showmouse;
end;

procedure TView.Schreibeneu(x1,y1,x2,y2:integer;zentriert:boolean;text:string;textcolor:word);
var xcor,ycor:integer;
    hs:string;
    alles,normal,tasten:string;
    c:char;
begin
  splitstr(text,alles,normal,tasten);
  if zentriert then begin
    xcor:=succ(x1+(((x2-x1)-(length(alles)*8)-2) div 2));
    ycor:=y1+((y2-y1-6) div 2);
  end else begin
    xcor:=x1;
    ycor:=y1;
  end;
  hidemouse;
  setcolor(lo(textcolor) and $F);
  outtextxy(xcor,ycor,normal);
  setcolor(hi(textcolor) and $F);
  outtextxy(xcor,ycor,tasten);
  showmouse;
end;

procedure TView.schreibecursorneu(x,y:integer;ch:char;textcolor,boxcolor:word);
begin
  hidemouse;
  setfillstyle(solidfill,hi(boxcolor) and $F);
  bar(x,y+2,x+16,y+10);
  setcolor(lo(textcolor) and $F);
  outtextxy(x,y,ch);
  setcolor(hi(textcolor) and $F);
  outtextxy(x+8,y,'_');
  showmouse;
end;

procedure TView.schreibecursor(x,y,curpos:integer;text:string;textcolor:word);
begin
  hidemouse;
  setcolor(lo(textcolor) and $F);
  outtextxy(x,y,text);
  setcolor(hi(textcolor) and $F);
  if curpos>length(text) then
    outtextxy(x+8*pred(curpos),y,'_')
  else outtextxy(x+8*pred(curpos),y,text[curpos]);
  showmouse;
end;

procedure TView.loschezeichen(x,y,count:integer;c:word);
begin
  hidemouse;
  setfillstyle(solidfill,hi(c) and $F);
  bar(x,y,x+8*count,y+8);
  showmouse;
end;

procedure TView.schreibechar(x,y:integer;ch:char;textcolor:word);
begin
  hidemouse;
  setcolor(lo(textcolor) and $F);
  outtextxy(x,y,ch);
  showmouse;
end;

procedure TView.Schaltereckig(x,y:integer;oben:boolean;boxcolor,schaltercolor:word);
begin
  hidemouse;
  fenster(x,y,x+10,y+10,0,0,0,0,boxcolor);
  if oben then begin
    setfillstyle(solidfill,hi(schaltercolor) and $F);
    bar(x+3,y+3,x+7,y+7);
    setcolor(lo(schaltercolor) and $F);
    graph.moveto(x+3,y+8);
    lineto(x+8,y+8);
    lineto(x+8,y+3);
    graph.moveto(x+4,y+9);
    lineto(x+9,y+9);
    lineto(x+9,y+4);
    putpixel(x+4,y+4,lo(schaltercolor) shr 4);
    putpixel(x+5,y+4,lo(schaltercolor) shr 4);
    putpixel(x+4,y+5,lo(schaltercolor) shr 4);
  end else begin
    setfillstyle(solidfill,hi(schaltercolor) shr 4);
    bar(x+3,y+3,x+7,y+7);
    putpixel(x+4,y+4,lo(schaltercolor) shr 4);
  end;
  showmouse;
end;

procedure TView.Schalterrund(x,y:integer;oben:boolean;boxcolor,schaltercolor:word);
begin
  hidemouse;
  setfillstyle(solidfill,hi(boxcolor) and $F);
  bar(succ(x),succ(y),x+9,y+9);
  setcolor(lo(boxcolor) and $F);
  arc(x+5,y+5,225,45,5);
  arc(x+5,y+5,45,225,4);
  setcolor(lo(boxcolor) shr 4);
  arc(x+5,y+5,225,45,4);
  arc(x+5,y+5,45,225,5);
  if oben then begin
    setcolor(lo(schaltercolor) and $F);
    circle(x+6,y+6,3);
    setfillstyle(solidfill,lo(schaltercolor) and $F);
    floodfill(x+6,y+6,lo(schaltercolor) and $F);
    setcolor(hi(schaltercolor) and $F);
    circle(x+5,y+5,2);
    setfillstyle(solidfill,hi(schaltercolor) and $F);
    floodfill(x+5,y+5,hi(schaltercolor) and $F);
    putpixel(x+4,y+4,lo(schaltercolor) shr 4);
    putpixel(x+5,y+4,lo(schaltercolor) shr 4);
    putpixel(x+4,y+5,lo(schaltercolor) shr 4);
  end else begin
    setcolor(hi(schaltercolor) shr 4);
    circle(x+5,y+5,2);
    setfillstyle(solidfill,hi(schaltercolor) shr 4);
    floodfill(x+5,y+5,hi(schaltercolor) shr 4);
    putpixel(x+4,y+4,lo(schaltercolor) shr 4);
  end;
  showmouse;
end;

{procedure TView.Dummy; tut nichts nur zu TestZwecken)
begin
end;}

procedure TViewCollection.ForEachBackWard(Action: Pointer);
type ActionProc=Procedure(Item:Pointer);
var n:word;
begin
  for n:=pred(count) downto 0 do ActionProc(action)(At(n));
end;

constructor TGroup.Init(var Bounds: TRect);
begin
  TView.init(Bounds);
  options:=ofselectable;
  eventmask:=$FFFF;
  SubViews:=new(PViewCollection,init(5,5));
  current:=nil;
  last:=nil;
end;

constructor TGroup.Load(Var S: TStream);
var HPeerPtr:PPeerViewPtr;
    aowner:PGroup;

  function suchesubview(Item:PView):boolean;far;
  begin
    suchesubview:=AktPeerViewPtr^.subview=item;
  end;

  procedure putowner(Item:PView);far;
  begin
    item^.owner:=aowner;
  end;

begin
  TView.Load(s);
  SubViews^.load(s);
  aowner:=@self;
  subviews^.foreach(@putowner);
  GetSubViewPtr(s,Last);
  GetSubViewPtr(s,Current);
  S.read(EndState,sizeof(endstate));
  S.read(Phase,sizeof(Phase));
  while (aktpeerviewptr<>nil) and ((subviews^.firstthat(@suchesubview)<>nil) or (AktPeerViewPtr^.number=-1)) do begin
    if AktPeerViewPtr^.number=-1 then aktpeerViewPtr^.ptr:=nil
    else aktpeerViewPtr^.ptr:=subviews^.At(AktPeerViewPtr^.number);
    hpeerptr:=aktpeerviewptr;
    aktpeerviewptr:=aktpeerviewptr^.last;
    dispose(hpeerptr);
  end;
end;

destructor TGroup.Done;
var hv:PView;
    n:integer;
begin
  for n:=0 to pred(subviews^.count) do begin
    hv:=subviews^.at(n);
    hv^.state:=hv^.state and not sfvisible;
    hv^.owner:=nil;{Damit TView.Done nicht Delete aufruft}
  end;
  current:=nil;
  last:=nil;
  TView.Done;
  current:=nil;
  last:=nil;
{  while subviews^.count>0 do begin
    hv:=subviews^.at(pred(subviews^.count));
    hv^.state:=hv^.state and not sfvisible;}
    {delete(hv);}
    {SubViews^.FreeItem(hv);ber TView.Done wird auch Delete aufgerufen}
{  end;}
  dispose(SubViews,done);
  subviews:=nil;
end;

procedure TGroup.ChangeBounds(var Bounds: TRect);
begin
  setbounds(bounds);
  DrawView;
end;

function TGroup.DataSize: Word;
var DatSize:Word;

  Procedure AddSize(Item: PView);far;
  begin
    Inc(DatSize,Item^.DataSize);
  end;

begin
  DatSize:=0;
  SubViews^.foreach(@AddSize);
  DataSize:=DatSize;
end;

procedure TGroup.searchfocus;
{Hat die Aufgabe einer Gruppe einen Selektierungspfad und eine fokussierte Subview zu verschaffen
 *Falls dies nicht geht, wird versucht eine nchsthhere andere zu selektieren*}
var count:word;

  procedure nextlevel;
  begin
    if (current<>nil) and ((current^.options and ofselectable)<>0) then current^.focus else begin
      current:=nil;
{      if owner<>nil then owner^.searchfocus;}
    end;
  end;

begin
  if (subviews^.count>1) then begin
    count:=0;
    if current=nil then begin
      current:=first;
    end else current:=current^.prev;
    while (current<>nil) and ((current^.options and ofselectable)=0) and (count<subviews^.count) do begin
      current:=current^.prev;
      inc(count);
    end;
    nextlevel;
  end else nextlevel;  {Nchster selektierbare wird selektiert, wenn der selektierte verschwindet}

    {Nur ZU TESTZWECKEN

  If current<>nil then current^.dummy;
  If last<>nil then last^.dummy;}

end;

procedure TGroup.Delete(P: PView);
var hown:pgroup;
    r,b:trect;
    prevv:PView;
    count:byte;
    buffered:boolean;
begin
  if p^.getstate(sfvisible) then begin
    hown:=p^.owner;
    if hown<>nil then begin
      count:=1;
      while hown^.owner<>nil do begin
        hown:=hown^.owner;
        inc(count);
      end;
      hown^.getbounds(r);
      b.a.x:=0;b.a.y:=0;
      b.b.x:=pred(screenwidth);b.b.y:=pred(screenheight);
      if r.equals(b) then begin
        buffered:=p^.getstate(sfbuffered);
        p^.setstate(sfvisible,false);
        if (count>=2) and (not buffered) then p^.owner^.drawview;
      end;
    end;
  end;
  Prevv:=P^.prev;
  prevv^.next:=p^.next;            {Vorgnger zeigt auf Nachfolger}
  if Last=p then Last:=prevv;      {Last wird auf Vorgnger eingestellt, wenn p der letzte war}
  SubViews^.AtDelete(SubViews^.IndexOf(P)); {der Eintrag von p verschwindet}
  if (Current=p) then begin
    current:=current^.next;
    if (current=p) then current:=nil;
    searchfocus;
  end;
  P^.Owner:=nil;               {Felder auf Nichts}
  P^.Next:=nil;
  {Nchster selektierbare wird selektiert, wenn der selektierte verschwindet}
  if SubViews^.count=0 then begin
    Current:=nil;   {wenn keine Subview mehr vorhanden, dann Selektierungspfad abbrechen}
    Last:=nil;
  end;

  {Nur ZU TESTZWECKEN

  If current<>nil then current^.dummy;
  If last<>nil then last^.dummy;}

end;

procedure TGroup.Draw;

  procedure neuzeichnen(Item:PView);far;
  begin
    item^.drawview;
  end;

begin
  if subviews<>nil then SubViews^.Foreach(@neuZeichnen);
end;

procedure TGroup.EndModal(Command: Word);
begin
  if Getstate(sfModal) then
    EndState:=Command {Execute gibt zurck an ExecView}
  else TView.endModal(command); {Mu noch berichtigt werden}
end;

procedure TGroup.EventError(var Event: TEvent);
begin
  if owner<>nil then owner^.EventError(event);
end;

function TGroup.ExecView(P: PView): Word;
var OldCurrent:PView;
    OldHelpContext:Word;
    OldCurCommands:TCommandset;
    nochnichtda:boolean;

  function sucheview(item: PView):boolean;far;
  begin
    sucheview:=p=item;
  end;

begin
  if p=nil then execview:=cmcancel else begin
    OldCurrent:=Current;
    OldHelpContext:=HelpCtx;
    getcommands(OldCurCommands);
    nochnichtda:=subviews^.firstthat(@sucheview)=nil;
    if nochnichtda then Insert(P);
    p^.setstate(sfmodal,true);
    ExecView:=P^.Execute;
    p^.setstate(sfmodal,false);
    if nochnichtda then Delete(p);
    setcommands(OldCurCommands);
    HelpCtx:=OldHelpContext;
    Current:=OldCurrent;

      {Nur ZU TESTZWECKEN

  If current<>nil then current^.dummy;
  If last<>nil then last^.dummy;}


  end;
end;

function TGroup.Execute: Word;
var e: TEvent;
begin
  repeat
    endstate:=0;
    repeat
      repeat getevent(e) until e.what<>evnothing;
      handleevent(e);
      if e.what <> evNothing then EventError(E);
    until EndState <> 0
  until Valid(EndState);
  Execute := EndState;
end;

function TGroup.First: PView;
begin
  if subviews^.count=0 then first:=nil else first:=subviews^.At(0);
end;

function TGroup.FirstThat(Test: Pointer):PView;
begin
  FirstThat:=SubViews^.FirstThat(test);
end;

procedure TGroup.ForEach(Action: Pointer);
begin
  SubViews^.ForEach(Action);
end;

procedure TGroup.GetData(var Rec);
var Aktpos:word;

  procedure HoleDaten(Item:PView);far;
  begin
    Item^.Getdata(Tbytearray(rec)[aktpos]);
    inc(aktpos,Item^.DataSize);
  end;

begin
  aktpos:=0;
  SubViews^.ForEach(@HoleDaten);
end;

function TGroup.GetHlpCtx: Word;
var hlpctx:word;
begin
  if (current<>nil) and (state and sffocused=0) then begin
    hlpctx:=current^.getHlpCtx;
    if hlpctx=hcNoContext then GetHlpCtx:=HelpCtx else GetHlpCtx:=hlpCtx;
  end else gethlpctx:=helpctx;
end;

function TGroup.GetShapeCtx:Word;
var shpctx:word;
begin
  if current<>nil then begin
    shpctx:=current^.getshapectx;
    if shpctx=scNormalShape then Getshapectx:=ShapeCtx else Getshapectx:=shpctx;
  end else getshapectx:=helpctx;
end;

function TGroup.GetPositionCtx:Word;
var Mousev:PView;

  function MausInView(Item:PView):boolean;far;
  begin
    MausInView:=Item^.MouseInView(MouseWhere);
  end;

begin
  MouseV:=SubViews^.lastthat(@MausInView);
  if (MouseV<>nil)
  then getPositionctx:=MouseV^.getPositionctx
  else getPositionctx:=scNormalShape;
end;

procedure TGroup.GetSubViewPtr(var S: TStream; P:PView);
var index:integer;
begin
  s.read(index,sizeof(index));
  if index=-1 then p:=nil else p:=subviews^.at(index);
end;

procedure TGroup.HandleEvent(var Event: TEvent);
var FocusedV:PView;
    n:word;
    item:PView;

  function MausInView(Item:PView):boolean;far;
  begin
    MausInView:=Item^.MouseInView(Event.Where);
  end;

  procedure broadcast(Item:PView);far;
  begin
    if ((item^.Eventmask and Event.what)>0) then Item^.handleevent(event);
  end;

begin
  if (event.what and focusedevents)>0 then begin
    Phase:=phPreProcess;
    for n:=subviews^.count downto 1 do begin
      item:=subviews^.at(pred(n));
      if ((item^.Eventmask and Event.what)>0) and
         ((item^.options and ofPreProcess)>0)
      then item^.handleevent(event);
    end;
    Phase:=phFocused;
    if current<>nil then current^.handleevent(event);
    Phase:=phPostProcess;
    for n:=subviews^.count downto 1 do begin
      item:=subviews^.at(pred(n));
      if ((item^.Eventmask and Event.what)>0) and
         ((item^.options and ofPostProcess)>0)
      then item^.handleevent(event);
    end;
  end else if (event.what and positionalevents)>0 then begin
    FocusedV:=SubViews^.lastthat(@MausInView);
    if (FocusedV<>nil) and ((FocusedV^.Eventmask and Event.what)>0) then FocusedV^.handleevent(event);
  end else 
  subviews^.foreach(@broadcast);
end;

procedure TGroup.Insert(P: PView);
var h,lastv:PView;
    r,b:trect;
    hown:PGroup;
begin
  if p<>nil then begin
    if subviews^.count>0 then lastv:=PView(subviews^.at(pred(subviews^.count))) else lastv:=nil;
    SubViews^.atInsert(SubViews^.count,P);
    p^.next:=subviews^.at(0);
    if lastv<>nil then lastv^.next:=p;
    last:=p;
    p^.owner:=@self;
    current:=p;{Stimmt das so ?}
    if p^.options and ofCenterx>0 then begin
      getextent(r);
      p^.getbounds(b);
      p^.origin.x:=(r.a.x+((r.b.x-r.a.x) div 2))-((b.b.x-b.a.x) div 2);
    end;
    if p^.options and ofCentery>0 then begin
      getextent(r);
      p^.getbounds(b);
      p^.origin.y:=(r.a.y+((r.b.y-r.a.y) div 2))-((b.b.y-b.a.y) div 2);
    end;
    {If (p^.options and ofSelectable)>0 then p^.setfocus;}
    if getstate(sfactive) then p^.state:=p^.state or sfactive;
    if p^.state and sfvisible>0 then begin
      hown:=p^.owner;               {knnte noch verndert werden mssen. Siehe auch InsertBefore und Delete}
      if hown<>nil then begin
        while hown^.owner<>nil do hown:=hown^.owner;
        hown^.getbounds(r);
        b.a.x:=0;b.a.y:=0;
        b.b.x:=pred(screenwidth);b.b.y:=pred(screenheight);
        if r.equals(b) then begin
          h:=current;
          repeat
            if (h^.options and ofSelectable)>0 then begin
              h^.setfocus;
              h:=nil;
            end else begin
              h:=h^.next;
              if h=current then h:=nil;
            end;
          until h=nil;
          p^.DrawView;{setstate(sfvisible,true);}
        end;
      end;
    end;
  end;

    {Nur ZU TESTZWECKEN

  If current<>nil then current^.dummy;
  If last<>nil then last^.dummy;}

end;

procedure TGroup.InsertBefore(P, Target: PView);
var Index:integer;
    r,b:trect;
    hown:PGroup;
begin
  Index:=subviews^.IndexOf(Target);
  if index>=0 then begin
    p^.next:=target;
    target^.prev^.next:=p;
    SubViews^.AtInsert(Index,p);
  end else begin
    SubViews^.AtInsert(0,p);
    p^.next:=last^.next;
    last^.next:=p;
  end;
  p^.owner:=@self;
  hown:=p^.owner;
  if hown<>nil then begin
    while hown^.owner<>nil do hown:=hown^.owner;
    hown^.getbounds(r);
    b.a.x:=0;b.a.y:=0;
    b.b.x:=pred(screenwidth);b.b.y:=pred(screenheight);
    if r.equals(b) then p^.setstate(sfvisible,true);
  end;
  If (p^.options and ofSelectable)>0 then p^.focus;

    {Nur ZU TESTZWECKEN

  If current<>nil then current^.dummy;
  If last<>nil then last^.dummy;}


end;

procedure TGroup.PutSubViewPtr(var S: TStream; P: PView);
var Index:Integer;
begin
  index:=subviews^.indexof(p);
  s.write(index,sizeof(index));
end;

procedure TGroup.Redraw;
begin
  draw; {Knnte gendert werden wenn Puffer verwendet werden sollen}
end;

procedure TGroup.SelectNext(Forwards: Boolean);
var HelpView:PView;
begin
  HelpView:=current;
  repeat
    if forwards then HelpView:=HelpView^.Next else HelpView:=HelpView^.Prev;
  until (HelpView=Current) or ((Helpview^.options and ofSelectable)>0);
  if HelpView<>current then HelpView^.focus;
end;

procedure TGroup.SetData(var Rec);
var Aktpos:word;
    n:word;
begin
  aktpos:=0;
  if (subviews<>nil) and (subviews^.count>0) then for n:=0 to pred(subviews^.count) do begin
    PView(subviews^.at(n))^.Setdata(Tbytearray(rec)[aktpos]);
    inc(aktpos,pview(subviews^.at(n))^.DataSize);
  end;
end;

procedure TGroup.SetState(AState: Word; Enable:Boolean);

  procedure SetEach(Item:PView);far;
  begin
    Item^.SetState(Astate,enable);
  end;

begin
  if (astate and (sfselected or sffocused)=0) and
     (subviews<>nil) and
     (subviews^.count>0) then SubViews^.ForEach(@SetEach);
  if (astate=sfvisible) and enable then state:=state or astate
  else TView.setstate(astate,enable);
  if ((astate and sffocused)>0) and enable then current:=nil;
end;

procedure TGroup.PutState(AState: Word; Enable:Boolean);

  procedure SetEach(Item:PView);far;
  begin
    Item^.PutState(Astate,enable);
  end;

begin
  if (astate and (sfselected or sffocused)=0) and
     (subviews<>nil) and
     (subviews^.count>0) then SubViews^.ForEach(@SetEach);
  if (astate=sfvisible) and enable then state:=state or astate
  else TView.Putstate(astate,enable);
  if ((astate and sffocused)>0) and enable then current:=nil;
end;


procedure TGroup.Store(var S: TStream);
begin
  TView.Store(s);
  PutSubViewPtr(s,Last);
  PutSubViewPtr(s,Current);
  S.write(EndState,sizeof(endstate));
  S.write(Phase,sizeof(Phase));
  SubViews^.store(s);
end;

function TGroup.Valid(Command: Word): Boolean;
var val:boolean;
    n:word;
begin
  val:=true;
  if (subviews<>nil) and (subviews^.count>0) then begin
    for n:=0 to pred(subviews^.count) do Val:=val and PView(subviews^.at(n))^.Valid(command);
  end;
  valid:=val;
end;


constructor TFrame.Init(var Bound,aRand: TRect);
begin
  TView.Init(Bound);
  rand:=arand;
  GrowMode:=growmode or gfgrowhix or gfgrowhiy;
  eventmask:=eventmask or evbroadcast or evMouseDown;
  buffer:=nil;
  correctrand:=true;
end;

destructor TFrame.done;
begin
  if buffer<>nil then freemem(buffer,imagesize(0,0,size.x,size.y));
  TView.Done;
end;

procedure TFrame.Store(var s:TStream);
begin
  TView.Store(s);
  s.write(rand,sizeof(rand));
end;

constructor TFrame.Load(var s:TStream);
begin
  TView.load(s);
  s.read(rand,sizeof(rand));
  correctrand:=true;
end;

procedure TFrame.Draw;
var R:trect;
    textcolor,boxcolor:word;
    buf:string[1];
    platz,l:byte;
begin
  if correctrand then begin
    if (rand.a.x<0) or ((PWindow(owner)^.flags and (wfclose or wfzoom))>0) or
       (PWindow(owner)^.title<>nil) or (PWindow(owner)^.number<>0) then rand.a.x:=13; {oben}
    if (rand.a.y<0) then rand.a.y:=13; {links}
    if (rand.b.x<0) then rand.b.x:=13; {unten}
    if (rand.b.y<0) or (PWindow(owner)^.flags and wfGrow>0) then rand.b.y:=13; {rechts}
    correctrand:=false;
  end;
  getextent(r);
  if getstate(sfvisible) then begin
    HideMouse;
    if getstate(sfactive) then boxcolor:=getcolor(6*256+3) else boxcolor:=getcolor(6*256+1);
    if owner^.options and (ofbuffered)>0 then begin
      if (buffer=nil) and (imagesize(r.a.x,r.a.y,r.b.x,r.b.y)<64*1024)
         and (maxavail>imagesize(r.a.x,r.a.y,r.b.x,r.b.y)+10000) then
         getmem(buffer,imagesize(r.a.x,r.a.y,r.b.x,r.b.y));
      if buffer<>nil then begin
        getimage(r.a.x,r.a.y,r.b.x,r.b.y,buffer^);
        owner^.state:=owner^.state or sfbuffered;
      end;
    end;
    if owner^.options and offramed>0 then
    fenster(r.a.x,r.a.y,r.b.x,r.b.y,rand.a.x,rand.a.y,rand.b.x,rand.b.y,boxcolor);
    if PWindow(owner)^.flags and wfclose>0 then begin
      textcolor:=getcolor(5);
      CloseSymbol(r.a.x+3,r.a.y+2,textcolor,boxcolor);
    end;
    if PWindow(owner)^.flags and wfZoom>0 then begin
      textcolor:=getcolor(5);
      ZoomSymbol(r.b.x-13,r.a.y+2,textcolor,boxcolor);
    end;
    if PWindow(owner)^.flags and wfGrow>0 then begin
      textcolor:=getcolor(5);
      GrowSymbol(r.b.x-13,r.b.y-13,textcolor,boxcolor);
    end;
    if PWindow(owner)^.title<>nil then begin
      if getstate(sfactive) then textcolor:=getcolor(4) else textcolor:=getcolor(2);
      platz:=(r.b.x-r.a.x-20*Byte(PWindow(owner)^.flags and wfclose>0)
              -20*byte(PWindow(owner)^.flags and wfZoom>0)) div 8;
      l:=platz div 2;
      schreibe(((r.b.x+r.a.x) div 2)-8*l,succ(r.a.y),
               ((r.b.x+r.a.x) div 2)+8*l,r.a.y+11,true,
               PWindow(owner)^.gettitle(platz),textcolor);
    end;
    if PWindow(owner)^.number<>0 then begin
      if getstate(sfactive) then textcolor:=getcolor(4) else textcolor:=getcolor(2);
      str(PWindow(owner)^.number:1,buf);
      schreibe(r.b.x-23,succ(r.a.y),r.b.x-14,r.a.y+11,true,buf,
               textcolor);
    end;
    ShowMouse;
  end else begin
    if buffer<>nil then begin
      hidemouse;
      putimage(r.a.x,r.a.y,buffer^,normalput);
      owner^.state:=owner^.state and not sfbuffered;
      showmouse;
      freemem(buffer,imagesize(r.a.x,r.a.y,r.b.x,r.b.y));
      buffer:=nil;
    end
  end;
end;

procedure TFrame.DrawRamen;
var R:trect;
    textcolor,boxcolor:word;
    buf:string[1];
    platz,l:byte;
begin
  getextent(r);
  if correctviewport and getstate(sfvisible) then begin
    HideMouse;
    if getstate(sfactive) then boxcolor:=getcolor(6*256+3) else boxcolor:=getcolor(6*256+1);
    if owner^.options and offramed>0 then
    fensterRamen(r.a.x,r.a.y,r.b.x,r.b.y,rand.a.x,rand.a.y,rand.b.x,rand.b.y,boxcolor);
    if PWindow(owner)^.title<>nil then begin
      if getstate(sfactive) then textcolor:=getcolor(4) else textcolor:=getcolor(2);
      platz:=(r.b.x-r.a.x-20*Byte(PWindow(owner)^.flags and wfclose>0)
              -20*byte(PWindow(owner)^.flags and wfZoom>0)) div 8;
      l:=platz div 2;
      schreibe(((r.b.x+r.a.x) div 2)-8*l,succ(r.a.y),
               ((r.b.x+r.a.x) div 2)+8*l,r.a.y+11,true,
               PWindow(owner)^.gettitle(platz),textcolor);
    end;
    if PWindow(owner)^.number<>0 then begin
      if getstate(sfactive) then textcolor:=getcolor(4) else textcolor:=getcolor(2);
      str(PWindow(owner)^.number:1,buf);
      schreibe(r.b.x-23,succ(r.a.y),r.b.x-14,r.a.y+11,true,buf,
               textcolor);
    end;
    ShowMouse;
  end else begin
    if buffer<>nil then begin
      hidemouse;
      putimage(r.a.x,r.a.y,buffer^,normalput);
      showmouse;
      freemem(buffer,imagesize(r.a.x,r.a.y,r.b.x,r.b.y));
      buffer:=nil;
    end
  end;
end;


procedure TFrame.DrawTitle;
var R:trect;
    textcolor,boxcolor:word;
    buf:string[1];
    platz,l:byte;
begin
  if (PWindow(owner)^.title<>nil) and getstate(sfvisible) and correctviewport then begin
    getextent(r);
    if getstate(sfactive) then boxcolor:=getcolor(6*256+3) else boxcolor:=getcolor(6*256+1);
    if getstate(sfactive) then textcolor:=getcolor(4) else textcolor:=getcolor(2);
    platz:=(r.b.x-r.a.x-20*Byte(PWindow(owner)^.flags and wfclose>0)
            -20*byte(PWindow(owner)^.flags and wfZoom>0)) div 8;
    l:=platz div 2;
    clearfeld(((r.b.x+r.a.x) div 2)-8*l,succ(r.a.y),
             ((r.b.x+r.a.x) div 2)+8*l,r.a.y+11,boxcolor);
    schreibe(((r.b.x+r.a.x) div 2)-8*l,succ(r.a.y),
             ((r.b.x+r.a.x) div 2)+8*l,r.a.y+11,true,
             PWindow(owner)^.gettitle(platz),textcolor);
  end;
end;

function TFrame.Getpalette: PPalette;
const
  CFrame = #1#6#2#7#3#8;
  PFrame: String[length(CFrame)] = CFrame;
begin
  getpalette:= @PFrame;
end;

procedure TFrame.HandleEvent(var Event: TEvent);
var r,ex:TRect;
    pos:TPoint;
    h:PView;
begin
  if event.what and positionalevents>0 then begin {Mausereignis}
    if event.what and evmousedown>0 then begin
      makelocal(event.where,pos);
      getextent(ex);
      if (not owner^.getstate(sfselected)) and
         ((pos.x<=rand.a.y) or {im linken rand}
          (pos.x>=ex.b.x-rand.b.y) or {im rechten Rand}
          (pos.y<=rand.a.x) or {im oberen rand}
          (pos.y>=ex.b.y-rand.b.y)) then {im unteren Rand}
        owner^.select;
      r.assign(2,2,13,13);
      if positionin(pos,r) then begin {CloseSymbol}
        if wfclose and PWindow(owner)^.flags>0 then begin
          if owner^.getstate(sfmodal)
          then owner^.endmodal(cmcancel)
          else message(owner,evcommand,cmclose,@self);
          clearevent(event);
        end;
      end else begin
        r.assign(ex.b.x-13,2,ex.b.x-2,13);
        if positionin(pos,r) then begin {ZoomSymbol}
          if wfzoom and PWindow(owner)^.flags>0 then begin

          end;
        end else begin
          r.assign(r.b.x-13,r.b.y-13,r.b.x-2,r.b.y-2);
          if positionin(pos,r) then begin {GrowSymbol}
            if wfgrow and PWindow(owner)^.flags>0 then begin

            end;
          end else begin
            r.assign(2,2,r.b.x,13);
            if positionin(pos,r) then begin {Move}
              if wfmove and PWindow(owner)^.flags>0 then begin
                owner^.owner^.getbounds(r);
                owner^.owner^.owner^.makeglobal(r.a,r.a);
                owner^.owner^.owner^.makeglobal(r.b,r.b);
                owner^.dragview(event,dmDragMove,r,r.a,r.a);
                clearevent(event);
              end;
            end;
          end;
        end;
      end;
    end else begin
    end;
  end else if event.what and focusedevents>0 then begin {Tastatur oder Kommando}

  end else begin {evBroadcast}

  end;
end;

procedure TFrame.SetState(AState: Word; Enable:Boolean); 
begin
  TView.setstate(astate,enable);
  if ((astate and sfactive)>0) then DrawRamen;
end;

function TFrame.GetPositionCtx:word;
var where:TPoint;
    ex,r:trect;
begin
  GetPositionCtx:=scNormalShape;
  makelocal(mousewhere,where);
  r.assign(2,2,13,13);
  if positionin(where,r) then begin
    if (wfclose and PWindow(owner)^.flags>0) then GetPositionCtx:=sccloseshape;
  end else begin
    getextent(ex);
    if (wfzoom and PWindow(owner)^.flags>0) then begin
      r.assign(ex.b.x-13,2,ex.b.x-2,13);
      if positionin(where,r) then GetPositionCtx:=sczoomshape;
    end;
    if (wfgrow and PWindow(owner)^.flags>0) then begin
      r.assign(ex.b.x-13,ex.b.y-13,ex.b.x-2,ex.b.y-2);
      if positionin(where,r) then GetPositionCtx:=scgrowshape;
    end;
    if (wfmove and PWindow(owner)^.flags>0) then begin
      r.assign(2,2,ex.b.x,13);
      if positionin(where,r) then GetPositionCtx:=scmoveshape;
    end;
  end;
end;

const dy=8;

constructor TListViewer.Init(var Bounds: TRect; ANumCols: Word; AHScrollBar, AVScrollBar: PScrollBar);
begin
  TView.Init(Bounds);
  NumCols:=ANumCols;
  Options:=Options or ofFirstClick or ofSelectable;
  EventMask:=EventMask or evBroadCast or evmousedown;
  Range:=0;
  Focused:=0;
  TopItem:=0;
  HScrollBar:=AHScrollBar;
  VScrollBar:=AVScrollBar;
  Zeilen:=(size.y-2) div dy;
  if HScrollBar<>nil then HScrollBar^.SetStep(zeilen,1);
  if VScrollBar<>nil then VScrollBar^.SetStep(zeilen,1);
  positionctx:=scListViewerShape;
end;

procedure TListViewer.Store(var S:TStream);
begin
  TView.Store(s);
  s.write(NumCols,sizeof(NumCols));
  s.write(TopItem,sizeof(TopItem));
  s.write(Focused,sizeof(Focused));
  s.write(Range,sizeof(Range));
  PutPeerViewPtr(s,HScrollBar);
  PutPeerViewPtr(s,VScrollBar);
end;

constructor TListViewer.Load(var S: TStream);
begin
  TView.Load(s);
  s.read(NumCols,sizeof(NumCols));
  s.read(TopItem,sizeof(TopItem));
  s.read(Focused,sizeof(Focused));
  s.read(Range,sizeof(Range));
  GetPeerViewPtr(s,HScrollBar);
  GetPeerViewPtr(s,VScrollBar);
  Zeilen:=(size.y-2) div dy;
end;

procedure TListViewer.ChangeBounds(var Bounds: TRect); 
begin
  TView.ChangeBounds(Bounds);
  Zeilen:=(size.y-2) div dy;
  if HScrollBar<>nil then HScrollBar^.SetStep(zeilen,1);
  if VScrollBar<>nil then VScrollBar^.SetStep(zeilen,1);
end;

procedure TListViewer.Draw;
var r:TRect;
    markcolor,textcolor,color,n,xcor,ycor:word;
    len,z:byte;
begin
  if getstate(sfvisible) then begin
    getextent(r);
    if getstate(sfactive) then textcolor:=getcolor(1)
    else textcolor:=getcolor(2);
    if getstate(sffocused) then markcolor:=getcolor(3)
    else markcolor:=getcolor(4);
    feld(r.a.x,r.a.y,r.b.x,r.b.y,false,getcolor(7*256+6));
    xcor:=2;
    ycor:=2;
    z:=1;
    len:=pred((r.b.x-r.a.x) div 8) div NumCols;
    for n:=TopItem to pred(TopItem+Zeilen*NumCols) do begin
      if focused=n then color:=markcolor else color:=textcolor;
      if n<range then schreibenormal(xcor,ycor,gettext(n,len),color);
      inc(ycor,dy);
      inc(z);
      if z>zeilen then begin
        z:=1;
        ycor:=2;
        inc(xcor,len*8+8);
      end;
    end;
    color:=getcolor(5);
    for n:=1 to pred(NumCols) do begin
      xcor:=2+n*(8*len+4);
      linie(xcor,succ(r.a.y),xcor,pred(r.b.y),color);
    end;
  end;
end;

procedure TListViewer.HandleEvent(var Event: TEvent);
var newitem:integer;
    myevent:boolean;
begin
  TView.Handleevent(event);
  case event.what of
    evmousedown:if event.double then begin
        message(owner,evbroadcast,cmdefault,@self);
      end else begin
        repeat
          makelocal(event.where,event.where);
          if (event.where.x<0) or (event.where.y<0) then newitem:=focused-zeilen
          else if (event.where.x>size.x) or (event.where.y>size.y) then newitem:=focused+zeilen else
          newitem:=topitem+(event.where.y div dy)+(event.where.x div ((pred(size.x div 8) div NumCols)*8))*zeilen;
          if newitem>=range then newitem:=pred(range);
          if newitem<0 then newitem:=0;
          if newitem<>focused then FocusItem(newitem);
        until not Mouseevent(event,evmousemove or evmouseauto);
        clearevent(event);
      end;
    evkeydown:begin
      myevent:=true;
      case event.keycode of
        kbPgDn:newitem:=focused+numcols*zeilen;
        kbPgUp:newitem:=focused-numcols*zeilen;
        kbCtrlPgDn:newitem:=pred(range);
        kbCtrlPgUp:newitem:=0;
        kbLeft:newitem:=focused-zeilen;
        kbRight:newitem:=focused+zeilen;
        kbUp:newitem:=pred(focused);
        kbDown:newitem:=succ(focused);
        else myevent:=false;
      end;
      if myevent then begin
        clearevent(event);
        if Newitem>=range then Newitem:=pred(range);
        if Newitem<0 then Newitem:=0;
        FocusItem(NewItem);
      end;
    end;
    evBroadCast:begin
      if (event.command=cmScrollbarChanged) then begin
        if (event.Infoptr=HScrollbar) then begin
          Setfocus;
          FocusItem(HScrollBar^.Value*zeilen);
        end else if (event.Infoptr=VScrollbar) then begin
          Setfocus;
          FocusItem(VScrollBar^.Value);
        end;
      end;
    end;
  end;
end;

procedure TListViewer.FocusItem(Item: Integer);
var oldTop:integer;
    color:word;
    r:TRect;
    viewportcorrected:boolean;

  procedure drawfocused;
  var len: byte;
  begin
    len:=pred((r.b.x-r.a.x) div 8) div NumCols;
    schreibenormal(2+(len*8+8)*((focused-topitem) div zeilen),
                   2+dy*(focused mod zeilen),
                   gettext(focused,len),color);
  end;

begin
  if focused<>item then begin
    getextent(r);
    if getstate(sfvisible) and correctviewport then begin
      viewportcorrected:=true;
      if getstate(sfactive) then color:=getcolor(1) else color:=getcolor(2);
      drawfocused;
    end else viewportcorrected:=false;
    if item>=range then item:=pred(range);
    if item<0 then item:=0;
    oldtop:=TopItem;
    if (item>=topitem+zeilen*Numcols) or (item<topitem) then
      topitem:=((item div zeilen)-((focused-topitem) div zeilen))*zeilen;
    focused:=item;
    if topitem<>oldtop then drawview
    else if getstate(sfvisible) and viewportcorrected then begin
      if getstate(sffocused) then color:=getcolor(3) else color:=getcolor(4);
      drawfocused;
    end;
    if vScrollBar<>nil then VScrollBar^.SetValue(Item);
  end;
end;

function TListViewer.GetPalette: PPalette; 
const
  CListViewer = #38#38#39#40#41#42#43;
  PListViewer: String[length(CListViewer)] = CListViewer;
begin
  getpalette:= @PListViewer;
end;

function TListViewer.GetText(Item: Integer; MaxLen: Integer): String;
begin
  abstract;
end;

function TListViewer.IsSelected(Item: Integer): Boolean; 
begin
  IsSelected:=Focused=Item;
end;

procedure TListViewer.SelectItem(Item: Integer); 
begin
  Message(Owner, evBroadCast, cmListItemSelected, @self);
end;

procedure TListViewer.SetRange(ARange: Integer);
begin
  Range:=ARange;
  if VScrollBar<>nil then VScrollbar^.SetRange(0,pred(ARange));
  if Focused>ARange then FocusItem(0);
end;

procedure TListViewer.SetState(AState: Word; ENable: Boolean); 
begin
  TView.SetState(Astate,enable);
  if (astate and (sfselected)>0) and enable then begin
    if VScrollBar<>nil then VScrollBar^.setstate(sfvisible,(astate and sfactive>0));
    if HScrollBar<>nil then HScrollBar^.setstate(sfvisible,(astate and sfactive>0));
  end;
  if (astate and sffocused>0) and enable then FocusItem(focused);
end;

constructor TScrollBar.Init(var Bounds: TREct);
begin
  TView.Init(Bounds);
  if (bounds.b.x-bounds.a.x)<(bounds.b.y-bounds.a.y) then begin
    {vertikal}
    Growmode:=growmode or gfGrowLox or gfGrowHix or GfGrowHiy;
  end else begin
    {horizontal}
    Growmode:=growmode or gfGrowLoy or gfGrowHix or GfGrowHiy;
  end;
  Value:=0;
  Min:=0;
  Max:=0;
  PgStep:=1;
  ArStep:=1;
  oldpart:=sbIndicator;
  EventMask:=EventMask or evMouseAuto;
end;

procedure TScrollBar.Store(var S: TStream);
begin
  TView.Store(s);
  s.write(Value,sizeof(Value));
  s.write(Min,sizeof(Min));
  s.write(Max,sizeof(Max));
  s.write(PgStep,sizeof(PgStep));
  s.write(ArStep,sizeof(ArStep));
end;

constructor TScrollBar.Load(var S: TStream);
begin
  TView.Load(s);
  s.read(Value,sizeof(Value));
  s.read(Min,sizeof(Min));
  s.read(Max,sizeof(Max));
  s.read(PgStep,sizeof(PgStep));
  s.read(ArStep,sizeof(ArStep));
  oldpart:=sbIndicator;
end;

procedure TScrollBar.Draw;
var r:TRect;
    color:word;
    pos,h,b:integer;
begin
  if getstate(sfvisible) then begin
    GetExtent(r);
    color:=getcolor(1*256+2);
    feld(r.a.x,r.a.y,r.b.x,r.b.y,false,color);
    if (r.b.x)<(r.b.y) then begin
      {vertikal}
      h:=pred((r.b.x-r.a.x) div 2);
      b:=(r.b.x-r.a.x)*3 div 2;
      arrow(succ(r.a.x),succ(r.a.y),pred(r.b.x),r.a.y+b,sbUpArrow,color);
      arrow(succ(r.a.x),r.b.y-B,pred(r.b.x),pred(r.b.y),sbDownArrow,color);
      if max=min then pos:=(r.a.y+r.b.y) div 2 else
      pos:=succ(r.a.y)+b+h+(longint(value-min)*longint(r.b.y-r.a.y-2*succ(b+h)) div (Max-Min));
      Indicator(succ(r.a.x),pos-h,pred(r.b.x),pos+h,color);
    end else begin
      {horizontal}
      h:=pred((r.b.y-r.a.y) div 2);
      b:=(r.b.y-r.a.y)*3 div 2;
      arrow(succ(r.a.x),succ(r.a.y),r.a.x+b,pred(r.b.y),sbLeftArrow,color);
      arrow(r.b.x-b,succ(r.a.y),pred(r.b.x),pred(r.b.y),sbRightArrow,color);
      if max=min then pos:=(r.a.x+r.b.x) div 2 else
      pos:=succ(r.a.x)+b+h+(longint(value-min)*longint(r.b.x-r.a.x-2*succ(b+h)) div (Max-Min));
      indicator(pos-h,succ(r.a.y),pos+h,pred(r.b.y),color);
    end;
  end;
end;

procedure TScrollBar.HandleEvent(var Event: TEvent);
var r:TRect;
    b,h:integer;
    pos,part,hvalue,oldvalue:integer;
    scrollkey:boolean;

  procedure SetNewIndicator(oldvalue:integer);
  var r:TRect;
      color:word;
      oldpos,pos,b,h:integer;
  begin
    if getstate(sfvisible) then begin
      GetExtent(r);
      color:=getcolor(1*256+2);
      if (r.b.x)<(r.b.y) then begin
        {vertikal}
        h:=pred((r.b.x-r.a.x) div 2);
        b:=(r.b.x-r.a.x)*3 div 2;
        if max=min then pos:=(r.a.y+r.b.y) div 2 else
        pos:=succ(r.a.y)+h+b+(longint(value-min)*longint(r.b.y-r.a.y-2*succ(b+h)) div (Max-Min));
        if max=min then oldpos:=pos else
        oldpos:=succ(r.a.y)+h+b+(longint(oldvalue-min)*longint(r.b.y-r.a.y-2*succ(b+h)) div (Max-Min));
        if oldpos<>pos then begin
          ClearFeld(succ(r.a.x),Oldpos-h,pred(r.b.x),Oldpos+h,color);
          Indicator(succ(r.a.x),pos-h,pred(r.b.x),pos+h,color);
        end;
      end else begin
        {horizontal}
        h:=pred((r.b.y-r.a.y) div 2);
        b:=(r.b.y-r.a.y)*3 div 2;
        if max=min then pos:=(r.a.x+r.b.x) div 2 else
        pos:=succ(r.a.x)+b+h+(longint(value-min)*longint(r.b.x-r.a.x-2*succ(b+h)) div (Max-Min));
        if max=min then oldpos:=pos else
        oldpos:=succ(r.a.x)+h+b+(longint(oldvalue-min)*longint(r.b.x-r.a.x-2*succ(b+h)) div (Max-Min));
        if oldpos<>pos then begin
          clearfeld(oldpos-h,succ(r.a.y),oldpos+h,pred(r.b.y),color);
          indicator(pos-h,succ(r.a.y),pos+h,pred(r.b.y),color);
        end;
      end;
    end;
  end;

  procedure presspart(part:byte);
  var delta,oldv:integer;
  begin
    delta:=ScrollStep(Part);
    if delta<>0 then begin
      oldv:=value;
      inc(value,delta);
      if value<min then value:=min else
      if value>max then value:=max;
      if oldv<>value then begin
        ScrollDraw;
        if correctviewport then SetNewIndicator(oldv);
      end;
    end;
  end;

  procedure setnewvalue(where:TPoint);
  var R:TRect;
      oldvalue:integer;
  begin
    GetExtent(r);
    oldvalue:=value;
    if (r.b.x)<(r.b.y) then begin
      {vertikal}
      h:=pred((r.b.x-r.a.x) div 2);
      b:=(r.b.x-r.a.x)*3 div 2;
      value:=longint(pred(where.y-r.a.y-b-h)*longint(Max-Min) div (r.b.y-r.a.y-2*succ(b+h)))+min;
    end else begin
      {horizontal}
      h:=pred((r.b.y-r.a.y) div 2);
      b:=(r.b.y-r.a.y)*3 div 2;
      value:=longint(pred(where.x-r.a.x-b-h)*longint(Max-Min) div (r.b.x-r.a.x-2*succ(b+h)))+min;
    end;
    if value<min then value:=min else
    if value>max then value:=max;
    if (oldvalue<>value) and correctviewport then begin
      SetNewIndicator(oldvalue);
    end;
  end;

begin
  TView.Handleevent(Event);
  case event.what of
    evkeydown:begin
      scrollkey:=true;
      if size.x>size.y then begin
        case event.keycode of
          kbCtrlLeft:part:=sbPageLeft;
          kbCtrlRight:part:=sbPageRight;
          kbLeft:part:=sbLeftArrow;
          kbRight:part:=sbRightArrow;
          else scrollkey:=false;
        end;
      end else begin
        case event.keycode of
          kbUp:part:=sbUpArrow;
          kbDown:part:=sbDownArrow;
          kbPgUp:part:=sbPageUp;
          kbPgDn:part:=sbPageDown;
          else scrollkey:=false;
        end;
      end;
      if scrollkey then begin
        presspart(part);
        clearevent(event);
      end;
    end;
    evMouseDown,evMouseAuto:begin
      makelocal(event.where,event.where);
      getextent(r);
      if event.what=evMouseDown then begin
        if r.b.x<r.b.y then begin
          h:=pred((r.b.x-r.a.x) div 2);
          b:=(r.b.x-r.a.x)*3 div 2;
          if max=min then pos:=(r.a.y+r.b.y) div 2 else
          pos:=succ(r.a.y)+b+h+(longint(value-min)*longint(r.b.y-r.a.y-2*succ(b+h)) div (Max-Min));
          if event.where.y>b then
          if event.where.y>pos-h then
          if event.where.y>pos+h then
          if event.where.y>r.b.y-b
          then part:=sbDownArrow
          else part:=sbPageDown
          else part:=sbIndicator
          else part:=sbPageUp
          else part:=sbUpArrow;
        end else begin
          {horizontal}
          h:=pred((r.b.y-r.a.y) div 2);
          b:=(r.b.y-r.a.y)*3 div 2;
          if max=min then pos:=(r.a.x+r.b.x) div 2 else
          pos:=succ(r.a.x)+b+h+(longint(value-min)*longint(r.b.x-r.a.x-2*succ(b+h)) div (Max-Min));
          if event.where.x>b then
          if event.where.x>pos-h then
          if event.where.x>pos+h then
          if event.where.x>r.b.x-b
          then part:=sbRightArrow
          else part:=sbPageRight
          else part:=sbIndicator
          else part:=sbPageLeft
          else part:=sbLeftArrow;
        end;
      end else part:=oldpart;
      oldpart:=part;
      if (part=sbIndicator) and (event.what=evmousedown) then begin
        oldValue:=value;
        repeat
          makelocal(event.where,event.where);
          if PositionIn(event.where,r) then
            setnewvalue(event.where)
          else begin
            if value<>oldvalue then begin
              hvalue:=value;
              value:=oldvalue;
              if correctviewport then setnewIndicator(hvalue);
            end;
          end;
        until not Mouseevent(event,evmousemove or evmouseauto);
        if value<>oldvalue then ScrollDraw;
      end else presspart(part);
      clearevent(event);
    end;
  end;
end;

function TScrollBar.GetPositionCtx:Word;
begin
  if size.x>size.y then GetPositionCtx:=scScrollHorizontalShape
  else GetPositionCtx:=scScrollVerticalShape;
end;

function TScrollBar.GetPalette: PPAlette; 
const
  CScrollBar = #4#5#5;
  PScrollBar: String[length(CScrollBar)] = CScrollBar;
begin
  getpalette:= @PScrollBar;
end;

procedure TScrollBar.ScrollDraw; 
begin
  Message(Owner, evBroadCast, cmScrollBarChanged, @self);
end;

function TScrollBar.ScrollStep(Part: Integer): Integer; 
begin
  case Part of
    sbLeftArrow,sbUpArrow:ScrollStep:=-ArStep;
    sbRightArrow,sbDownArrow:ScrollStep:=ArStep;
    sbPageLeft,sbPageUp:ScrollStep:=-PgStep;
    sbPageRight,sbPageDown:ScrollStep:=PgStep;
    else ScrollStep:=0;
  end;
end;

procedure TScrollBar.SetParams(AValue, AMin, AMax, APgStep, AArStep: Integer);
var h:Integer;
begin
  if AMin>Amax then begin
    h:=amin;
    amin:=amax;
    amax:=h;
  end;
  if avalue<amin then avalue:=amin;
  if avalue>amax then avalue:=amax;
  min:=amin;
  max:=amax;
  Pgstep:=APgStep;
  ArStep:=AArStep;
  h:=value;
  value:=AValue;
  DrawView;
  if h<>value then ScrollDraw;
end;

procedure TScrollBar.SetRange(AMin, AMax: Integer);
begin
  SetParams(Value,Amin,AMax,PgStep,ArStep);
end;

procedure TScrollBar.SetStep(APgStep, AArStep: Integer);
begin
  SetParams(Value,min,Max,APgStep,AArStep);
end;

procedure TScrollBar.SetValue(AValue: Integer);
begin
  SetParams(AValue,min,Max,PgStep,ArStep);
end;

constructor TScroller.Init(var Bounds: TRect; AHScrollBar, AVScrollBar: PScrollBar);
begin
end;

constructor TScroller.Load(var S: TStream);
begin
end;

procedure TScroller.ChangeBounds(var Bounds: TRect); 
begin
end;

function TScroller.GetPalette: PPAlette; 
begin
  abstract;
end;

procedure TScroller.HandleEvent(var Event: TEvent); 
begin
end;

procedure TScroller.ScrollDraw; 
begin
end;

procedure TScroller.ScrollTo(x,y: Integer);
begin
end;

procedure TScroller.SetLimit(x,y: Integer);
begin
end;

procedure TScroller.SetState(AState: Word; Enable: Boolean); 
begin
end;

procedure TScroller.Store(var S: TStream);
begin
end;

constructor TWindow.Init(var Bounds: TRect; ATitle: TTitlestr; ANumber: Integer);
begin
  TGroup.Init(Bounds);
  ZoomRect:=Bounds;
  Options:=Options or ofSelectable or ofTopSelect or offramed;
  state:=state or sfactive;
  Flags:=wfMove or wfGrow or wfClose or wfZoom;
  Title:=NewStr(ATitle);
  Number:=ANumber;
  palette:=wpBlueWindow;
  InitFrame;
end;

procedure TWindow.Store(var S: TStream);
begin
  TGroup.Store(s);
  s.write(flags,sizeof(flags));
  s.write(ZoomRect,sizeof(ZoomRect));
  s.write(Number,sizeof(Number));
  s.write(Palette,sizeof(Palette));
  s.writestr(title);
  putsubviewptr(s,frame);
end;

constructor TWindow.Load(var S: TStream);
var buf:array[0..255] of byte;
    len:byte;
begin
  TGroup.Load(s);
  s.read(flags,sizeof(flags));
  s.read(ZoomRect,sizeof(ZoomRect));
  s.read(Number,sizeof(Number));
  s.read(Palette,sizeof(Palette));
  title:=s.readstr;
  getsubviewptr(s,PView(frame));
end;

destructor TWindow.Done;
begin
  Disposestr(title);
  TGroup.Done;
end;

procedure TWindow.Close; 
begin
  if Valid(cmclose) then begin
    if getstate(sfmodal) then endmodal(cmcancel)
    else dispose(PWindow(@self),done);
    
  end;
end;

function TWindow.Getpalette: PPalette; 
const
  CBlueWindow=#8#9#10#11#12#13#14#15;
  CCyanWindow=#19#20#21#22#23#24#25#26;
  CGrayWindow=#30#31#32#33#34#35#36#37;
  P: array[wpBlueWindow..wpGrayWindow] of string[Length(CBlueWindow)] =
    (CBlueWindow, CCyanWindow, CGrayWindow);
begin
  GetPalette := @P[Palette];
end;

function TWindow.GetTitle(MaxSize: Integer): TTitleStr; 
begin
  if maxsize>length(title^) then Gettitle:=copy(title^,1,maxsize)
  else GetTitle:=title^;
end;

Procedure TWindow.SetTitle(ATitle: TTitleStr);
begin
  disposestr(title);
  title:=newstr(ATitle);
  Frame^.DrawTitle;
end;

procedure TWindow.HandleEvent(var Event: TEvent);
var myevent:boolean;
begin
  if event.what and evkeydown>0 then begin
    myevent:=true;
    case event.keycode of
      kbTab:selectnext(true);
      kbShiftTab:selectnext(false);
      else myevent:=false;
    end;
    if myevent then clearevent(event);
  end else if event.what and evBroadCast>0 then begin
    {case event.command of
      cmReceivedFocus : current:=event.InfoPtr;   Test 1.4.93
    end;}
  end else if event.what and evcommand>0 then begin
    case event.command of
      cmcancel,cmclose:begin
        close;
        clearevent(event);
        exit;
      end;
    end;
  end;
  TGroup.HandleEvent(Event);
end;

procedure TWindow.InitFrame;
var b,r:TRect;
begin
  r.assign(0,0,size.x,size.y);
  b.assign(2,2,2,2);
  new(Frame,Init(r,b));
  insert(frame);
end;

procedure TWindow.SetState(AState: Word; Enable: Boolean); 
begin
  TGroup.SetState(AState,Enable);
  {Kommandoset ndern}
end;

procedure TWindow.SizeLimits(var Min,Max: TPoint); 
begin
  TView.SizeLimits(Min,Max);
  {?}
end;

function TWindow.StandardScrollBar(AOptions: Word): PScrollBar;
begin
  abstract;
end;

procedure TWindow.Zoom; 
begin

end;

procedure TView.UnFocus;{beseitigt die Fokusierung des letzten Objekts eines selektierungspfeades}
begin
  setstate(sffocused,false);
end;

procedure TView.Select;
begin
  if not selectpfad then begin {Wenn das Objekt schon im aktuellen Selektierugspfad ist macht Focus keinen Sinn}
    if (owner<>nil) then begin
      if (owner^.current<>@self) then begin
        if owner^.current<>nil then begin
          owner^.current^.setstate(sfselected,false);{In jeder Gruppe darf nur ein Objekt selektiert sein}
          owner^.current^.unfocus; {Beseitige die Fokussierung des letzten Objekts}
        end;
        owner^.current:=@self;{Lege die Selektierung auf mich}
      end;
      owner^.select; {Sorge dafr, da auch alle Owners im Selektierungspfad liegen}
    end;
    if (options and ofTopSelect)>0 then MakeFirst; {Ich werde als oberster genommen und evtl. neu dargestellt}
    setstate(sfselected,true); {Ich werde selektiert}
  end;

      {Nur ZU TESTZWECKEN
  if owner<>nil then begin
    owner^.dummy;
    If owner^.current<>nil then owner^.current^.dummy;
    If owner^.last<>nil then owner^.last^.dummy;
  end;}



end;

function TView.selectpfad:boolean;
{Object ist im aktuellen Selektierungspfad
 Diese Function ist ntig, weil sfSelect nur die zuletzt selektierte Subview
 der Gruppe anzeigt, auch wenn diese nicht mehr selektiert ist}
var akt:PView;
    hilf:boolean;
begin
  hilf:=true;
  akt:=@self;
  while (akt^.owner<>nil) and hilf do begin
    hilf:=akt^.owner^.current=akt;
    akt:=akt^.owner;
  end;
  selectpfad:=hilf;
end;

function TView.getfocused:PView;
begin
  getfocused:=@self;
end;

procedure TView.Focus;
begin
  Select; {Ich werde selektiert}
  setstate(sffocused,true);{Ich werde fokussiert}
end;

procedure TView.SetUnFocus;
begin
  state:=state and not sffocused;
  message(owner,evBroadcast,cmReleasedFocus,@self);
end;

procedure TView.SetSelect;
begin
  if not selectpfad then begin {Wenn das Objekt schon im aktuellen Selektierugspfad ist macht Focus keinen Sinn}
    if (owner<>nil) then begin
      if (owner^.current<>@self) then begin
        if owner^.current<>nil then begin
          owner^.current^.state:=owner^.current^.state and not sfselected;{In jeder Gruppe darf nur ein Objekt selektiert sein}
          owner^.current^.Setunfocus; {Beseitige die Fokussierung des letzten Objekts}
        end;
        owner^.current:=@self;{Lege die Selektierung auf mich}
      end;
      owner^.Setselect; {Sorge dafr, da auch alle Owners im Selektierungspfad liegen}
    end;
    if (options and ofTopSelect)>0 then MakeFirst; {Ich werde als oberster genommen und evtl. neu dargestellt}
    state:=state or sfselected; {Ich werde selektiert}
  end;

      {Nur ZU TESTZWECKEN
  if owner<>nil then begin
    owner^.dummy;
    If owner^.current<>nil then owner^.current^.dummy;
    If owner^.last<>nil then owner^.last^.dummy;
  end;}



end;

procedure TView.SetFocus;
begin
  setselect;
  state:=state or sffocused;
  message(owner,evBroadcast,cmReceivedFocus,@self);
end;

function TGroup.getfocused:PView;
begin
  if selectpfad then begin
    if current<>nil then getfocused:=current^.getfocused else getfocused:=@self;
  end else begin
    if owner<>nil then getfocused:=owner^.getfocused else getfocused:=nil;
  end;
end;

procedure TGroup.Focus;
begin
  TView.Select;
  if current=nil then searchfocus;
end;

procedure TGroup.SetFocus;
begin
  TView.SetSelect;
  if current=nil then searchfocus;
end;

procedure TGroup.UnFocus;
begin
  if current<>nil then current^.unfocus;
  setstate(sffocused,false);
end;

procedure TGroup.SetUnFocus;
begin
  if current<>nil then current^.Setunfocus;
  state:=state and not sffocused;
end;

procedure TWindow.Select;
begin
  if not selectpfad then begin {Wenn das Objekt schon im aktuellen Selektierugspfad ist macht Focus keinen Sinn}
    if (owner<>nil) then begin
      if (owner^.current<>@self) then begin
        if owner^.current<>nil then begin
          owner^.current^.setstate(sfselected,false);{In jeder Gruppe darf nur ein Objekt selektiert sein}
          owner^.current^.setstate(sfactive,false);
          owner^.current^.unfocus; {Beseitige die Fokussierung des letzten Objekts}
        end;
        owner^.current:=@self;{Lege die Selektierung auf mich}
      end;
      owner^.select; {Sorge dafr, da auch alle Owners im Selektierungspfad liegen}
    end;
    if (options and ofTopSelect)>0 then MakeFirst; {Ich werde als oberster genommen und evtl. neu dargestellt}
    setstate(sfselected,true); {Ich werde selektiert}
    setstate(sfactive,true);
  end;

      {Nur ZU TESTZWECKEN
  if owner<>nil then begin
    owner^.dummy;
    If owner^.current<>nil then owner^.current^.dummy;
    If owner^.last<>nil then owner^.last^.dummy;
  end;}



end;

procedure TWindow.SetSelect;
begin
  if not selectpfad then begin {Wenn das Objekt schon im aktuellen Selektierugspfad ist macht Focus keinen Sinn}
    if (owner<>nil) then begin
      if (owner^.current<>@self) then begin
        if owner^.current<>nil then begin
          owner^.current^.state:=owner^.current^.state and not sfselected;
          {In jeder Gruppe darf nur ein Objekt selektiert sein}
          owner^.current^.state:=state and not sfactive;
          owner^.current^.setunfocus; {Beseitige die Fokussierung des letzten Objekts}
        end;
        owner^.current:=@self;{Lege die Selektierung auf mich}
      end;
      owner^.setselect; {Sorge dafr, da auch alle Owners im Selektierungspfad liegen}
    end;
    if (options and ofTopSelect)>0 then MakeFirst; {Ich werde als oberster genommen und evtl. neu dargestellt}
    state:=state or sfselected; {Ich werde selektiert}
    state:=state or sfactive;
  end;

      {Nur ZU TESTZWECKEN
  if owner<>nil then begin
    owner^.dummy;
    If owner^.current<>nil then owner^.current^.dummy;
    If owner^.last<>nil then owner^.last^.dummy;
  end;}



end;

const CloseShape:TShape = (relx:7;rely:7;
      shape : (screen : ($FC7F,$FC7F,$CC67,$C447,
                         $E00F,$F01F,$0000,$0100,
                         $0000,$F01F,$E00F,$C447,
                         $CC47,$FC7F,$FC7F,$FC7F);
               mask   : ($0100,$0100,$0100,$1110,
                         $0920,$0540,$0380,$FEFE,
                         $0380,$0540,$0920,$1110,
                         $0100,$0100,$0100,$0000));
          number:scCloseShape);
      ZoomShape:TShape = (relx:7;rely:7;
      shape : (screen : ($FF7F,$FE3F,$FC1F,$F80F,
                         $F007,$E223,$E633,$FE3F,
                         $FE3F,$E633,$E223,$F007,
                         $F80F,$FC1F,$FE3F,$FF7F);
               mask   : ($0000,$0080,$01C0,$02A0,
                         $0490,$0888,$0080,$0080,
                         $0080,$0080,$0888,$0490,
                         $02A0,$01C0,$0080,$0000));
          number:scZoomShape);
      GrowShape:TShape = (relx:7;rely:7;
      shape : (screen : ($007F,$007F,$007F,$07FF,
                         $03FF,$11FF,$18FF,$1C78,
                         $1E38,$FF18,$FF88,$FFC0,
                         $FFE0,$FE00,$FE00,$FE00);
               mask   : ($0000,$7F00,$6000,$5000,
                         $4800,$4400,$4200,$4100,
                         $0082,$0042,$0022,$0012,
                         $000A,$0006,$00FE,$0000));
          number:scGrowShape);
      MoveShape:TShape = (relx:7;rely:7;
      shape : (screen : ($FEFF,$FC7F,$F83F,$F01F,
                         $E00F,$E00F,$FC7F,$FC7F,
                         $FC7F,$FC7F,$E00F,$E00F,
                         $F01F,$F83F,$FC7F,$FEFF);
               mask   : ($0000,$0100,$0380,$07C0,
                         $0FE0,$0100,$0100,$0100,
                         $0100,$0100,$0100,$0FE0,
                         $07C0,$0380,$0100,$0000));
          number:scMoveShape);
      ScrollHorizontalShape:TShape = (relx:7;rely:7;
      shape : (screen : ($FFFF,$FFFF,$FFFF,$FFFF,
                         $FFFF,$EFF7,$C7E3,$8001,
                         $1818,$8001,$C7E3,$EFF7,
                         $FFFF,$FFFF,$FFFF,$FFFF);
               mask   : ($0000,$0000,$0000,$0000,
                         $0000,$0000,$1008,$381C,
                         $67E6,$381C,$1008,$0000,
                         $0000,$0000,$0000,$0000));
          number:scScrollHorizontalShape);
      ScrollVerticalShape:TShape = (relx:7;rely:7;
      shape : (screen : ($FF7F,$FE3F,$FC1F,$F88F,
                         $FC9F,$FE3F,$FE3F,$FE3F,
                         $FE3F,$FE3F,$FE3F,$FC9F,
                         $F88F,$FC1F,$FE3F,$FF7F);
               mask   : ($0000,$0080,$01C0,$0360,
                         $0140,$0080,$0080,$0080,
                         $0080,$0080,$0080,$0140,
                         $0360,$01C0,$0080,$0000));
          number:scScrollVerticalShape);
      ListViewerShape:TShape = (relx:7;rely:7;
      shape : (screen : ($FEFF,$FC7F,$F83F,$F01F,
                         $EEEF,$CEE7,$8FE3,$0381,
                         $8FE3,$CEE7,$EEEF,$F01F,
                         $F83F,$FC7F,$FEFF,$FFFF);
               mask   : ($0000,$0100,$0380,$07C0,
                         $0100,$1110,$3018,$7C7C,
                         $3018,$1110,$0100,$07C0,
                         $0380,$0100,$0000,$0000));
          number:scListViewerShape);

begin
  MouseCursor^.RegisterShape(@CloseShape);
  MouseCursor^.RegisterShape(@ZoomShape);
  MouseCursor^.RegisterShape(@GrowShape);
  MouseCursor^.RegisterShape(@MoveShape);
  MouseCursor^.RegisterShape(@ScrollVerticalShape);
  MouseCursor^.RegisterShape(@ScrollHorizontalShape);
  MouseCursor^.RegisterShape(@ListViewerShape);
end.
