program TestDesign;
uses crt,graph,vga;
{$R-}
var graphdriver,graphmode:integer;
    maxx,maxy,maxcolor:word;
    modus:boolean;
    ein:char;
type TColorPalette= array[0..15,0..2] of byte;
     TTransLate=array[0..15] of byte;
const TransLate:TTransLate= (0,1,2,3,4,5,20,7,56,57,58,59,60,61,62,63);
      ColorPalette:TColorPalette = ((00,00,00), {schwarz}
                                    (16,16,16), {grau0}
                                    (32,32,32), {grau1}
                                    (48,48,48), {grau2}
                                    (63,00,00), {rot}
                                    (00,63,00), {grn}
                                    (00,00,63), {blau}
                                    (00,63,63), {cyan}
                                    (63,63,00), {gelb}
                                    (63,00,63), {magenta}
                                    (63,32,63),
                                    (00,48,00),
                                    (00,40,00),
                                    (00,32,00),
                                    (00,16,00),
                                    (63,63,63)); {wei}

const schwarz=0;
      grau0=1;
      grau1=2;
      grau2=3;
      rot  =4;
      gruen=5;
      blau =6;
      cyan =7;
      gelb =8;
      magenta=9;
      weiss  =15;
      oben=true;
      unten=false;

  procedure Feld(x1,y1,x2,y2:integer;oben:boolean);
  begin
    if oben then setcolor(grau2) else setcolor(grau0);
    moveto(x2,y1);
    lineto(x1,y1);
    lineto(x1,y2);
    if oben then setcolor(grau0) else setcolor(grau2);
    moveto(succ(x1),y2);
    lineto(x2,y2);
    lineto(x2,succ(y1));
    setfillstyle(solidfill,grau1);
    bar(succ(x1),succ(y1),pred(x2),pred(y2));
  end;

  procedure Schreibe(x1,y1,x2,y2:integer;oben:boolean;text:string);
  var xcor,ycor:integer;
  begin
    feld(x1,y1,x2,y2,oben);
    setcolor(schwarz);
    xcor:=succ(x1+(((x2-x1)-(length(text)*8)-2) div 2));
    ycor:=y1+((y2-y1-6) div 2);
    outtextxy(succ(xcor),succ(ycor),text);
    setcolor(weiss);
    outtextxy(xcor,ycor,text);
  end;

  procedure Fenster(x1,y1,x2,y2:integer;o,l,u,r:byte);
  begin
    setfillstyle(solidfill,grau1);
    bar(succ(x1),succ(y1),pred(x2),pred(y2));
    setcolor(grau2);
    moveto(x2,y1);
    lineto(x1,y1);
    lineto(x1,y2);
    moveto(x1+l+2,pred(y2-u));
    lineto(pred(x2-r),pred(y2-u));
    lineto(pred(x2-r),y1+o+2);
    setcolor(grau0);
    moveto(pred(x2-r),succ(y1+o));
    lineto(succ(x1+l),succ(y1+o));
    lineto(succ(x1+l),pred(y2-u));
    moveto(succ(x1),y2);
    lineto(x2,y2);
    lineto(x2,succ(y1));
  end;

  procedure Schaltereckig(x,y:integer;oben:boolean);
  begin
    fenster(x-5,y-5,x+5,y+5,0,0,0,0);
    if oben then begin
      setfillstyle(solidfill,gruen);
      bar(x-2,y-2,x+2,y+2);
      setcolor(grau0);
      moveto(x-2,y+3);
      lineto(x+3,y+3);
      lineto(x+3,y-2);
      moveto(x-1,y+4);
      lineto(x+4,y+4);
      lineto(x+4,y-1);
      putpixel(pred(x),pred(y),weiss);
      putpixel(x,pred(y),weiss);
      putpixel(pred(x),y,weiss);
    end else begin
      setfillstyle(solidfill,rot);
      bar(x-2,y-2,x+2,y+2);
      putpixel(pred(x),pred(y),weiss);
    end;
  end;

  procedure Schalterrund(x,y:integer;oben:boolean);
  begin
    setfillstyle(solidfill,grau1);
    bar(succ(x),succ(y),x+9,y+9);
    setcolor(grau0);
    arc(x+5,x+5,225,45,5);
    arc(x+5,x+5,45,225,4);
    setcolor(grau2);
    arc(x+5,x+5,225,45,4);
    arc(x+5,x+5,45,225,5);
    if oben then begin
      setcolor(grau0);
      circle(x+6,y+6,3);
      setfillstyle(solidfill,grau0);
      floodfill(x+6,y+6,grau0);
      setcolor(gruen);
      circle(x+5,y+5,2);
      setfillstyle(solidfill,gruen);
      floodfill(x+5,y+5,gruen);
      putpixel(x+4,y+4,weiss);
      putpixel(x+5,y+4,weiss);
      putpixel(x+4,y+5,weiss);
    end else begin
      setcolor(rot);
      circle(x+5,y+5,2);
      setfillstyle(solidfill,rot);
      floodfill(x+5,y+5,rot);
      putpixel(x+4,y+4,weiss);
    end;
  end;

{  procedure CloseSymbol(x,y:integer;textcolor,boxcolor:word);
  var x1,y1,x2,y2:integer;
  begin
    feld(x,y,x+10,y+10,boxcolor);
    setcolor(lo(textcolor) and $F);
    inc(x);inc(y);
    for x1:=0 to 2 do for y1:=0 to 2 do for x2:=0 to 2 do for y2:=0 to 2 do
    line(x+x1*4,y+y1*4,x+x2*4,y+y2*4);
  end;
 }
  procedure SetNewPalette;
  var c:byte;
  begin
    for c:=0 to 15 do farbe(Translate[c],colorpalette[c,0],colorpalette[c,1],colorpalette[c,2]);
  end;

  procedure Testcolor;
  var c:byte;
      buf:string[2];
  begin
    setcolor(0);
    for c:=0 to 15 do begin
      setfillstyle(solidfill,c);
      bar(c*(maxx div 16),0,succ(c)*(maxx div 16),maxx div 16);
      str(c:2,buf);
      setcolor(0);
      outtextxy(c*maxx div 16,maxx div 32,buf);
      setcolor(15);
      outtextxy(pred(c*maxx div 16),pred(maxx div 32),buf);
    end;
  end;

procedure colorcycle;
var c,r,g,b:byte;
    buf:string[3];
begin
  for c:=0 to 255 do begin
    lesefarbe(c,r,g,b);
    farbe(c,21,34,62);
    str(c:3,buf);
    setfillstyle(solidfill,0);
    bar(10,maxx div 16,40,10+maxx div 16);
    setcolor(0);
    outtextxy(10,maxx div 16,buf);
    setcolor(15);
    outtextxy(11,succ(maxx div 16),buf);
    repeat until keypressed;
    while keypressed do readkey;
    farbe(c,r,g,b);
  end;
end;

procedure initvideo;
var grapherror:integer;
begin
  graphdriver:=detect;
  initgraph(graphdriver,graphmode,'');
  grapherror:=graphresult;
  if grapherror<>0 then begin
    writeln(grapherrormsg(graphresult));
    halt(11);
  end;
  maxx:=getmaxx;
  maxy:=getmaxy;
  maxcolor:=getmaxcolor;
end;

{$L EGAVGA}
procedure EGAVGAdriver;external;

begin
  if (registerbgidriver(@EGAVGAdriver)<0) then begin
    writeln('Fehler beim Anmelden der Grfaiktreiber! (TGDRIVER)');
    halt(10);
  end;
  InitVideo;
  setfillstyle(solidfill,grau1);
  bar(0,0,pred(maxx),pred(maxy));
  SetNewPalette;
  TestColor;
{  ColorCycle;}
  fenster(100,100,400,300,18,2,2,12);
  feld(103,102,387,116,unten);
  schreibe(104,103,150,115,oben,'Hallo');
  schreibe(151,103,200,115,oben,'Ich');
  schreibe(201,103,250,115,unten,'Du');
  schreibe(251,103,300,115,oben,'Er');
  schreibe(301,103,350,115,oben,'Sie');
  schaltereckig(400,400,oben);
  modus:=true;
  repeat
    schalterrund(440,440,not modus);
    schaltereckig(400,400,modus);
    schreibe(201,103,250,115,modus,'Du');
    modus:=not modus;
    repeat until keypressed;
    while keypressed do ein:=readkey;
  until ein=#27;
  closegraph;
end.