program install_roll;
uses TGapp,Objects, TGDriver, TGViews, TGMenus, TGDialog;
const cminstall= 100;
type PInstall=^TInstall;
     TInstall=object(TApplication)
                constructor init;
                procedure initmenubar; virtual;
                procedure handleevent(var event:tevent); virtual;
                function installdialog:word;
                procedure infowindow;
              end;
     TDialogData=record
                   Karte,Sound,Eingabe:word;
                   Datei:string;
                 end;
var Dialogdata:Tdialogdata;

procedure Tinstall.infowindow;
var d:Pdialog;
    r:trect;
    control:word;
begin
  r.assign(0,0,54*8,13*10);
  d:=new(pdialog,init(r,'Information'));
  with d^ do begin
    Options := Options or ofCentered;
    R.Assign(18*8,2*10,52*8,3*10);
    Insert(New(PStaticText, Init(R,'Jump ''n'' Roll')));
    R.Assign(7*8,4*10,52*8,5*10);
    Insert(New(PStaticText, Init(R,'(c) 1991 Mathias & Florian Schreck')));
    R.Assign(4*8,6*10,52*8,7*10);
    Insert(New(PStaticText, Init(R,'Jump ''n'' Roll funktioniert nur mit VGA Karte !')));
    R.Assign(4*8,8*10,52*8,9*10);
    Insert(New(PStaticText, Init(R,'Rufen Sie Jump ''n'' Roll mit "Jump<" auf !')));
    R.Assign(20*8, 10*10, 30*8, 12*10);
    Insert(New(PButton, Init(R, '~O~K', cmOk, bfDefault)));
  end;
  if ValidView(D) <> nil then
  begin
    control:=Desktop^.ExecView(D);
    Dispose(D, Done);
  end;
end;

function Tinstall.installdialog:word;
var
  D: PDialog;
  Control: word;
  R: TRect;
  bruce:PView;
begin
  R.Assign(0, 0, 54*8+4, 24*12+4);
  D := New(PDialog, Init(R, 'Install'));
  with D^ do
  begin
    Options := Options or ofCentered;
    R.Assign(3*8,2*12,52*8+4,3*12+4);
    Insert(New(PStaticText, Init(R,'Jump ''n'' Roll funktioniert nur mit VGA Karte !')));
    R.assign(2*8,5*12,52*8+4,7*12+4);
    bruce:=new(PRadioButtons,init(r,
      newsitem('Sound ~B~laster',
      newsitem('~G~ame Blaster',
      newsitem('Ad~L~ib',
      newsitem('~I~nterner Lautsprecher',nil))))));
    insert(bruce);
    R.Assign(2*8,4*12-4,52*8+4,5*12);
    Insert(New(PLabel, Init(R,'Welche Sound~k~arte hast Du ?',bruce)));
    R.assign(2*8,9*12,52*8+4,12*12+4);
    bruce:=new(PCheckBoxes,init(r,
      newsitem('M~u~sik         (Sound Blaster / AdLib)',
      newsitem('~F~ahrgerusche (Sound Blaster / Game Blaster)',
      newsitem('~S~prache       (Sound Blaster)',nil)))));
    insert(bruce);
    R.Assign(2*8,8*12-4,52*8+4,9*12);
    Insert(New(PLabel, Init(R,'Welche ~S~ound-Effekte willst Du ?',bruce)));
    R.assign(2*8,14*12,52*8+4,15*12+4);
    bruce:=new(PRadioButtons,init(r,
      newsitem('~J~oystick',
      newsitem('~M~aus',
      newsitem('~T~astatur',nil)))));
    insert(bruce);
    R.Assign(2*8,13*12-4,52*8+4,14*12);
    Insert(New(PLabel, Init(R,'Welches ~E~ingabegert willst Du benutzen ?',bruce)));
    R.Assign(2*8, 16*12, 12*8+4, 18*12+4);
    Insert(New(PButton, Init(R, '~O~K', cmOk, bfDefault)));
    R.Assign(16*8 ,16*12, 28*8+4, 18*12+4);
    Insert(New(PButton, Init(R, 'C~a~ncel', cmCancel, bfNormal)));
    R.Assign(2*8,20*12,50*8,21*12+3);
    bruce:=New(PInputLine,init(r,255));
    insert(bruce);
    R.Assign(2*8,19*12-2,50*8,20*12-2);
    Insert(New(PLabel, Init(R,'~N~ame der Level:',bruce)));
    R.Assign(2*8,22*12,50*8,22*12+10);
    bruce:=New(PScrollBar,init(r));
    PScrollBar(bruce)^.setparams(10,0,50,10,1);
    insert(bruce);
  end;
  if ValidView(D) <> nil then
  begin
    d^.setdata(dialogdata);
    control:=Desktop^.ExecView(D);
    if control<>cmcancel then d^.getdata(dialogdata);
    Dispose(D, Done);
  end;
  installdialog:=control;
end;

procedure TInstall.initmenubar;
var r:TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 12;
  menubar:=new(PMenubar, Init(r,
   newmenu(
    newsubmenu('~J~ump ''n'' Roll',hcNoContext,
       newmenu(newitem('~I~nstall','',kbnokey,cminstall,hcnocontext,
       newitem('~Q~uit','',kbALTx,cmquit,hcnocontext,nil)
       ))
    ,nil))));
end;

procedure tinstall.handleevent(var event:tevent);
begin
  TApplication.HandleEvent(Event);
  case Event.What of
    evCommand:
      begin
        case Event.Command of
          cminstall:if installdialog<>cmcancel then begin
                      ClearEvent(Event);
                      endmodal(cmquit);
                    end;
        else
          Exit;
        end;
        ClearEvent(Event);
      end;
  end;
end;

constructor TInstall.init;
begin
  TApplication.init;
  with Dialogdata do begin
    karte:=0;sound:=1+2+4;eingabe:=0;
    datei:='Hallo, dies ist eine Eingabezeile. Hier gehts weiter -> -> Geschafft !';
  end;
end;

{procedure machebatch;
var t:text;
begin
  assign(t,'JUMP.BAT');
  rewrite(t);
  with DialogData do begin
    writeln(t,'@ECHO OFF');
    if (((sound and 1)>0) and ((karte=0) or (karte=2))) then writeln(t,'SOUND b9000');
    write(t,'TITEL');
    if (((sound and 1)>0) and ((karte=0) or (karte=2))) then writeln(t,' M') else writeln(t);
    write(t,'ROLL STAGE0 ');
    case karte of
      0:write(t,'S');
      1:write(t,'G');
      2:write(t,'A');
      3:write(t,'I');
    end;
    write(t,' ');
    if (sound and 4)>0 then write(t,'S ') else write(t,'X ');
    if (sound and 2)>0 then write(t,'F ') else write(t,'X ');
    if (sound and 1)>0 then write(t,'M ') else write(t,'X ');
    case eingabe of
      0:writeln(t,'J');
      1:writeln(t,'M');
      2:writeln(t,'T');
    end;
  end;
  close(t);
end;
}

procedure machebatch;
var d:PDialog;
type Tparam=array[0..4] of longint;
var paramdata:TParam;
    r:Trect;
begin
  r.assign(0,0,350,200);
  new(d,init(r,'Ergebnis'));
  d^.options:=D^.options or ofcentered;
  with DialogData do begin
    paramdata[0]:=karte;
    paramdata[1]:=sound;
    paramdata[2]:=eingabe;
    Pstring(paramdata[3]):=@datei;
  end;
  r.assign(20,20,330,180);
  d^.insert(new(PParamText,init(r,'karte %d'#13'sound %d'#13'eingabe %d'#13'Datei:'#13'%s',3)));
  d^.setdata(paramdata);
  desktop^.execview(d);
  dispose(d,done);
end;

var Install:TInstall;
begin
  install.init;
  if Install.installdialog<>cmcancel then begin
    machebatch;
    install.infowindow;
  end;
  install.done;
end.